(function() {
    var AjaxMonitor, Bar, DocumentMonitor, ElementMonitor, ElementTracker, EventLagMonitor, Evented, Events, NoTargetError, Pace, RequestIntercept, SOURCE_KEYS, Scaler, SocketRequestTracker, XHRRequestTracker, animation, avgAmplitude, bar, cancelAnimation, cancelAnimationFrame, defaultOptions, extend, extendNative, getFromDOM, getIntercept, handlePushState, ignoreStack, init, now, options, requestAnimationFrame, result, runAnimation, scalers, shouldIgnoreURL, shouldTrack, source, sources, uniScaler, _WebSocket, _XDomainRequest, _XMLHttpRequest, _i, _intercept, _len, _pushState, _ref, _ref1, _replaceState,
      __slice = [].slice,
      __hasProp = {}.hasOwnProperty,
      __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
      __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };
  
    defaultOptions = {
      catchupTime: 100,
      initialRate: .03,
      minTime: 250,
      ghostTime: 100,
      maxProgressPerFrame: 20,
      easeFactor: 1.25,
      startOnPageLoad: true,
      restartOnPushState: true,
      restartOnRequestAfter: 500,
      target: 'body',
      elements: {
        checkInterval: 100,
        selectors: ['body']
      },
      eventLag: {
        minSamples: 10,
        sampleCount: 3,
        lagThreshold: 3
      },
      ajax: {
        trackMethods: ['GET'],
        trackWebSockets: true,
        ignoreURLs: []
      }
    };
  
    now = function() {
      var _ref;
      return (_ref = typeof performance !== "undefined" && performance !== null ? typeof performance.now === "function" ? performance.now() : void 0 : void 0) != null ? _ref : +(new Date);
    };
  
    requestAnimationFrame = window.requestAnimationFrame || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame || window.msRequestAnimationFrame;
  
    cancelAnimationFrame = window.cancelAnimationFrame || window.mozCancelAnimationFrame;
  
    if (requestAnimationFrame == null) {
      requestAnimationFrame = function(fn) {
        return setTimeout(fn, 50);
      };
      cancelAnimationFrame = function(id) {
        return clearTimeout(id);
      };
    }
  
    runAnimation = function(fn) {
      var last, tick;
      last = now();
      tick = function() {
        var diff;
        diff = now() - last;
        if (diff >= 33) {
          last = now();
          return fn(diff, function() {
            return requestAnimationFrame(tick);
          });
        } else {
          return setTimeout(tick, 33 - diff);
        }
      };
      return tick();
    };
  
    result = function() {
      var args, key, obj;
      obj = arguments[0], key = arguments[1], args = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
      if (typeof obj[key] === 'function') {
        return obj[key].apply(obj, args);
      } else {
        return obj[key];
      }
    };
  
    extend = function() {
      var key, out, source, sources, val, _i, _len;
      out = arguments[0], sources = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      for (_i = 0, _len = sources.length; _i < _len; _i++) {
        source = sources[_i];
        if (source) {
          for (key in source) {
            if (!__hasProp.call(source, key)) continue;
            val = source[key];
            if ((out[key] != null) && typeof out[key] === 'object' && (val != null) && typeof val === 'object') {
              extend(out[key], val);
            } else {
              out[key] = val;
            }
          }
        }
      }
      return out;
    };
  
    avgAmplitude = function(arr) {
      var count, sum, v, _i, _len;
      sum = count = 0;
      for (_i = 0, _len = arr.length; _i < _len; _i++) {
        v = arr[_i];
        sum += Math.abs(v);
        count++;
      }
      return sum / count;
    };
  
    getFromDOM = function(key, json) {
      var data, e, el;
      if (key == null) {
        key = 'options';
      }
      if (json == null) {
        json = true;
      }
      el = document.querySelector("[data-pace-" + key + "]");
      if (!el) {
        return;
      }
      data = el.getAttribute("data-pace-" + key);
      if (!json) {
        return data;
      }
      try {
        return JSON.parse(data);
      } catch (_error) {
        e = _error;
        return typeof console !== "undefined" && console !== null ? console.error("Error parsing inline pace options", e) : void 0;
      }
    };
  
    Evented = (function() {
      function Evented() {}
  
      Evented.prototype.on = function(event, handler, ctx, once) {
        var _base;
        if (once == null) {
          once = false;
        }
        if (this.bindings == null) {
          this.bindings = {};
        }
        if ((_base = this.bindings)[event] == null) {
          _base[event] = [];
        }
        return this.bindings[event].push({
          handler: handler,
          ctx: ctx,
          once: once
        });
      };
  
      Evented.prototype.once = function(event, handler, ctx) {
        return this.on(event, handler, ctx, true);
      };
  
      Evented.prototype.off = function(event, handler) {
        var i, _ref, _results;
        if (((_ref = this.bindings) != null ? _ref[event] : void 0) == null) {
          return;
        }
        if (handler == null) {
          return delete this.bindings[event];
        } else {
          i = 0;
          _results = [];
          while (i < this.bindings[event].length) {
            if (this.bindings[event][i].handler === handler) {
              _results.push(this.bindings[event].splice(i, 1));
            } else {
              _results.push(i++);
            }
          }
          return _results;
        }
      };
  
      Evented.prototype.trigger = function() {
        var args, ctx, event, handler, i, once, _ref, _ref1, _results;
        event = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
        if ((_ref = this.bindings) != null ? _ref[event] : void 0) {
          i = 0;
          _results = [];
          while (i < this.bindings[event].length) {
            _ref1 = this.bindings[event][i], handler = _ref1.handler, ctx = _ref1.ctx, once = _ref1.once;
            handler.apply(ctx != null ? ctx : this, args);
            if (once) {
              _results.push(this.bindings[event].splice(i, 1));
            } else {
              _results.push(i++);
            }
          }
          return _results;
        }
      };
  
      return Evented;
  
    })();
  
    Pace = window.Pace || {};
  
    window.Pace = Pace;
  
    extend(Pace, Evented.prototype);
  
    options = Pace.options = extend({}, defaultOptions, window.paceOptions, getFromDOM());
  
    _ref = ['ajax', 'document', 'eventLag', 'elements'];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      source = _ref[_i];
      if (options[source] === true) {
        options[source] = defaultOptions[source];
      }
    }
  
    NoTargetError = (function(_super) {
      __extends(NoTargetError, _super);
  
      function NoTargetError() {
        _ref1 = NoTargetError.__super__.constructor.apply(this, arguments);
        return _ref1;
      }
  
      return NoTargetError;
  
    })(Error);
  
    Bar = (function() {
      function Bar() {
        this.progress = 0;
      }
  
      Bar.prototype.getElement = function() {
        var targetElement;
        if (this.el == null) {
          targetElement = document.querySelector(options.target);
          if (!targetElement) {
            throw new NoTargetError;
          }
          this.el = document.createElement('div');
          this.el.className = "pace pace-active";
          document.body.className = document.body.className.replace(/pace-done/g, '');
          document.body.className += ' pace-running';
          this.el.innerHTML = '<div class="pace-progress">\n  <div class="pace-progress-inner"></div>\n</div>\n<div class="pace-activity"></div>';
          if (targetElement.firstChild != null) {
            targetElement.insertBefore(this.el, targetElement.firstChild);
          } else {
            targetElement.appendChild(this.el);
          }
        }
        return this.el;
      };
  
      Bar.prototype.finish = function() {
        var el;
        el = this.getElement();
        el.className = el.className.replace('pace-active', '');
        el.className += ' pace-inactive';
        document.body.className = document.body.className.replace('pace-running', '');
        return document.body.className += ' pace-done';
      };
  
      Bar.prototype.update = function(prog) {
        this.progress = prog;
        return this.render();
      };
  
      Bar.prototype.destroy = function() {
        try {
          this.getElement().parentNode.removeChild(this.getElement());
        } catch (_error) {
          NoTargetError = _error;
        }
        return this.el = void 0;
      };
  
      Bar.prototype.render = function() {
        var el, key, progressStr, transform, _j, _len1, _ref2;
        if (document.querySelector(options.target) == null) {
          return false;
        }
        el = this.getElement();
        transform = "translate3d(" + this.progress + "%, 0, 0)";
        _ref2 = ['webkitTransform', 'msTransform', 'transform'];
        for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
          key = _ref2[_j];
          el.children[0].style[key] = transform;
        }
        if (!this.lastRenderedProgress || this.lastRenderedProgress | 0 !== this.progress | 0) {
          el.children[0].setAttribute('data-progress-text', "" + (this.progress | 0) + "%");
          if (this.progress >= 100) {
            progressStr = '99';
          } else {
            progressStr = this.progress < 10 ? "0" : "";
            progressStr += this.progress | 0;
          }
          el.children[0].setAttribute('data-progress', "" + progressStr);
        }
        return this.lastRenderedProgress = this.progress;
      };
  
      Bar.prototype.done = function() {
        return this.progress >= 100;
      };
  
      return Bar;
  
    })();
  
    Events = (function() {
      function Events() {
        this.bindings = {};
      }
  
      Events.prototype.trigger = function(name, val) {
        var binding, _j, _len1, _ref2, _results;
        if (this.bindings[name] != null) {
          _ref2 = this.bindings[name];
          _results = [];
          for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
            binding = _ref2[_j];
            _results.push(binding.call(this, val));
          }
          return _results;
        }
      };
  
      Events.prototype.on = function(name, fn) {
        var _base;
        if ((_base = this.bindings)[name] == null) {
          _base[name] = [];
        }
        return this.bindings[name].push(fn);
      };
  
      return Events;
  
    })();
  
    _XMLHttpRequest = window.XMLHttpRequest;
  
    _XDomainRequest = window.XDomainRequest;
  
    _WebSocket = window.WebSocket;
  
    extendNative = function(to, from) {
      var e, key, _results;
      _results = [];
      for (key in from.prototype) {
        try {
          if ((to[key] == null) && typeof from[key] !== 'function') {
            if (typeof Object.defineProperty === 'function') {
              _results.push(Object.defineProperty(to, key, {
                get: function() {
                  return from.prototype[key];
                },
                configurable: true,
                enumerable: true
              }));
            } else {
              _results.push(to[key] = from.prototype[key]);
            }
          } else {
            _results.push(void 0);
          }
        } catch (_error) {
          e = _error;
        }
      }
      return _results;
    };
  
    ignoreStack = [];
  
    Pace.ignore = function() {
      var args, fn, ret;
      fn = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      ignoreStack.unshift('ignore');
      ret = fn.apply(null, args);
      ignoreStack.shift();
      return ret;
    };
  
    Pace.track = function() {
      var args, fn, ret;
      fn = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      ignoreStack.unshift('track');
      ret = fn.apply(null, args);
      ignoreStack.shift();
      return ret;
    };
  
    shouldTrack = function(method) {
      var _ref2;
      if (method == null) {
        method = 'GET';
      }
      if (ignoreStack[0] === 'track') {
        return 'force';
      }
      if (!ignoreStack.length && options.ajax) {
        if (method === 'socket' && options.ajax.trackWebSockets) {
          return true;
        } else if (_ref2 = method.toUpperCase(), __indexOf.call(options.ajax.trackMethods, _ref2) >= 0) {
          return true;
        }
      }
      return false;
    };
  
    RequestIntercept = (function(_super) {
      __extends(RequestIntercept, _super);
  
      function RequestIntercept() {
        var monitorXHR,
          _this = this;
        RequestIntercept.__super__.constructor.apply(this, arguments);
        monitorXHR = function(req) {
          var _open;
          _open = req.open;
          return req.open = function(type, url, async) {
            if (shouldTrack(type)) {
              _this.trigger('request', {
                type: type,
                url: url,
                request: req
              });
            }
            return _open.apply(req, arguments);
          };
        };
        window.XMLHttpRequest = function(flags) {
          var req;
          req = new _XMLHttpRequest(flags);
          monitorXHR(req);
          return req;
        };
        try {
          extendNative(window.XMLHttpRequest, _XMLHttpRequest);
        } catch (_error) {}
        if (_XDomainRequest != null) {
          window.XDomainRequest = function() {
            var req;
            req = new _XDomainRequest;
            monitorXHR(req);
            return req;
          };
          try {
            extendNative(window.XDomainRequest, _XDomainRequest);
          } catch (_error) {}
        }
        if ((_WebSocket != null) && options.ajax.trackWebSockets) {
          window.WebSocket = function(url, protocols) {
            var req;
            if (protocols != null) {
              req = new _WebSocket(url, protocols);
            } else {
              req = new _WebSocket(url);
            }
            if (shouldTrack('socket')) {
              _this.trigger('request', {
                type: 'socket',
                url: url,
                protocols: protocols,
                request: req
              });
            }
            return req;
          };
          try {
            extendNative(window.WebSocket, _WebSocket);
          } catch (_error) {}
        }
      }
  
      return RequestIntercept;
  
    })(Events);
  
    _intercept = null;
  
    getIntercept = function() {
      if (_intercept == null) {
        _intercept = new RequestIntercept;
      }
      return _intercept;
    };
  
    shouldIgnoreURL = function(url) {
      var pattern, _j, _len1, _ref2;
      _ref2 = options.ajax.ignoreURLs;
      for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
        pattern = _ref2[_j];
        if (typeof pattern === 'string') {
          if (url.indexOf(pattern) !== -1) {
            return true;
          }
        } else {
          if (pattern.test(url)) {
            return true;
          }
        }
      }
      return false;
    };
  
    getIntercept().on('request', function(_arg) {
      var after, args, request, type, url;
      type = _arg.type, request = _arg.request, url = _arg.url;
      if (shouldIgnoreURL(url)) {
        return;
      }
      if (!Pace.running && (options.restartOnRequestAfter !== false || shouldTrack(type) === 'force')) {
        args = arguments;
        after = options.restartOnRequestAfter || 0;
        if (typeof after === 'boolean') {
          after = 0;
        }
        return setTimeout(function() {
          var stillActive, _j, _len1, _ref2, _ref3, _results;
          if (type === 'socket') {
            stillActive = request.readyState < 2;
          } else {
            stillActive = (0 < (_ref2 = request.readyState) && _ref2 < 4);
          }
          if (stillActive) {
            Pace.restart();
            _ref3 = Pace.sources;
            _results = [];
            for (_j = 0, _len1 = _ref3.length; _j < _len1; _j++) {
              source = _ref3[_j];
              if (source instanceof AjaxMonitor) {
                source.watch.apply(source, args);
                break;
              } else {
                _results.push(void 0);
              }
            }
            return _results;
          }
        }, after);
      }
    });
  
    AjaxMonitor = (function() {
      function AjaxMonitor() {
        var _this = this;
        this.elements = [];
        getIntercept().on('request', function() {
          return _this.watch.apply(_this, arguments);
        });
      }
  
      AjaxMonitor.prototype.watch = function(_arg) {
        var request, tracker, type, url;
        type = _arg.type, request = _arg.request, url = _arg.url;
        if (shouldIgnoreURL(url)) {
          return;
        }
        if (type === 'socket') {
          tracker = new SocketRequestTracker(request);
        } else {
          tracker = new XHRRequestTracker(request);
        }
        return this.elements.push(tracker);
      };
  
      return AjaxMonitor;
  
    })();
  
    XHRRequestTracker = (function() {
      function XHRRequestTracker(request) {
        var event, size, _j, _len1, _onreadystatechange, _ref2,
          _this = this;
        this.progress = 0;
        if (window.ProgressEvent != null) {
          size = null;
          request.addEventListener('progress', function(evt) {
            if (evt.lengthComputable) {
              return _this.progress = 100 * evt.loaded / evt.total;
            } else {
              return _this.progress = _this.progress + (100 - _this.progress) / 2;
            }
          }, false);
          _ref2 = ['load', 'abort', 'timeout', 'error'];
          for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
            event = _ref2[_j];
            request.addEventListener(event, function() {
              return _this.progress = 100;
            }, false);
          }
        } else {
          _onreadystatechange = request.onreadystatechange;
          request.onreadystatechange = function() {
            var _ref3;
            if ((_ref3 = request.readyState) === 0 || _ref3 === 4) {
              _this.progress = 100;
            } else if (request.readyState === 3) {
              _this.progress = 50;
            }
            return typeof _onreadystatechange === "function" ? _onreadystatechange.apply(null, arguments) : void 0;
          };
        }
      }
  
      return XHRRequestTracker;
  
    })();
  
    SocketRequestTracker = (function() {
      function SocketRequestTracker(request) {
        var event, _j, _len1, _ref2,
          _this = this;
        this.progress = 0;
        _ref2 = ['error', 'open'];
        for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
          event = _ref2[_j];
          request.addEventListener(event, function() {
            return _this.progress = 100;
          }, false);
        }
      }
  
      return SocketRequestTracker;
  
    })();
  
    ElementMonitor = (function() {
      function ElementMonitor(options) {
        var selector, _j, _len1, _ref2;
        if (options == null) {
          options = {};
        }
        this.elements = [];
        if (options.selectors == null) {
          options.selectors = [];
        }
        _ref2 = options.selectors;
        for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
          selector = _ref2[_j];
          this.elements.push(new ElementTracker(selector));
        }
      }
  
      return ElementMonitor;
  
    })();
  
    ElementTracker = (function() {
      function ElementTracker(selector) {
        this.selector = selector;
        this.progress = 0;
        this.check();
      }
  
      ElementTracker.prototype.check = function() {
        var _this = this;
        if (document.querySelector(this.selector)) {
          return this.done();
        } else {
          return setTimeout((function() {
            return _this.check();
          }), options.elements.checkInterval);
        }
      };
  
      ElementTracker.prototype.done = function() {
        return this.progress = 100;
      };
  
      return ElementTracker;
  
    })();
  
    DocumentMonitor = (function() {
      DocumentMonitor.prototype.states = {
        loading: 0,
        interactive: 50,
        complete: 100
      };
  
      function DocumentMonitor() {
        var _onreadystatechange, _ref2,
          _this = this;
        this.progress = (_ref2 = this.states[document.readyState]) != null ? _ref2 : 100;
        _onreadystatechange = document.onreadystatechange;
        document.onreadystatechange = function() {
          if (_this.states[document.readyState] != null) {
            _this.progress = _this.states[document.readyState];
          }
          return typeof _onreadystatechange === "function" ? _onreadystatechange.apply(null, arguments) : void 0;
        };
      }
  
      return DocumentMonitor;
  
    })();
  
    EventLagMonitor = (function() {
      function EventLagMonitor() {
        var avg, interval, last, points, samples,
          _this = this;
        this.progress = 0;
        avg = 0;
        samples = [];
        points = 0;
        last = now();
        interval = setInterval(function() {
          var diff;
          diff = now() - last - 50;
          last = now();
          samples.push(diff);
          if (samples.length > options.eventLag.sampleCount) {
            samples.shift();
          }
          avg = avgAmplitude(samples);
          if (++points >= options.eventLag.minSamples && avg < options.eventLag.lagThreshold) {
            _this.progress = 100;
            return clearInterval(interval);
          } else {
            return _this.progress = 100 * (3 / (avg + 3));
          }
        }, 50);
      }
  
      return EventLagMonitor;
  
    })();
  
    Scaler = (function() {
      function Scaler(source) {
        this.source = source;
        this.last = this.sinceLastUpdate = 0;
        this.rate = options.initialRate;
        this.catchup = 0;
        this.progress = this.lastProgress = 0;
        if (this.source != null) {
          this.progress = result(this.source, 'progress');
        }
      }
  
      Scaler.prototype.tick = function(frameTime, val) {
        var scaling;
        if (val == null) {
          val = result(this.source, 'progress');
        }
        if (val >= 100) {
          this.done = true;
        }
        if (val === this.last) {
          this.sinceLastUpdate += frameTime;
        } else {
          if (this.sinceLastUpdate) {
            this.rate = (val - this.last) / this.sinceLastUpdate;
          }
          this.catchup = (val - this.progress) / options.catchupTime;
          this.sinceLastUpdate = 0;
          this.last = val;
        }
        if (val > this.progress) {
          this.progress += this.catchup * frameTime;
        }
        scaling = 1 - Math.pow(this.progress / 100, options.easeFactor);
        this.progress += scaling * this.rate * frameTime;
        this.progress = Math.min(this.lastProgress + options.maxProgressPerFrame, this.progress);
        this.progress = Math.max(0, this.progress);
        this.progress = Math.min(100, this.progress);
        this.lastProgress = this.progress;
        return this.progress;
      };
  
      return Scaler;
  
    })();
  
    sources = null;
  
    scalers = null;
  
    bar = null;
  
    uniScaler = null;
  
    animation = null;
  
    cancelAnimation = null;
  
    Pace.running = false;
  
    handlePushState = function() {
      if (options.restartOnPushState) {
        return Pace.restart();
      }
    };
  
    if (window.history.pushState != null) {
      _pushState = window.history.pushState;
      window.history.pushState = function() {
        handlePushState();
        return _pushState.apply(window.history, arguments);
      };
    }
  
    if (window.history.replaceState != null) {
      _replaceState = window.history.replaceState;
      window.history.replaceState = function() {
        handlePushState();
        return _replaceState.apply(window.history, arguments);
      };
    }
  
    SOURCE_KEYS = {
      ajax: AjaxMonitor,
      elements: ElementMonitor,
      document: DocumentMonitor,
      eventLag: EventLagMonitor
    };
  
    (init = function() {
      var type, _j, _k, _len1, _len2, _ref2, _ref3, _ref4;
      Pace.sources = sources = [];
      _ref2 = ['ajax', 'elements', 'document', 'eventLag'];
      for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
        type = _ref2[_j];
        if (options[type] !== false) {
          sources.push(new SOURCE_KEYS[type](options[type]));
        }
      }
      _ref4 = (_ref3 = options.extraSources) != null ? _ref3 : [];
      for (_k = 0, _len2 = _ref4.length; _k < _len2; _k++) {
        source = _ref4[_k];
        sources.push(new source(options));
      }
      Pace.bar = bar = new Bar;
      scalers = [];
      return uniScaler = new Scaler;
    })();
  
    Pace.stop = function() {
      Pace.trigger('stop');
      Pace.running = false;
      bar.destroy();
      cancelAnimation = true;
      if (animation != null) {
        if (typeof cancelAnimationFrame === "function") {
          cancelAnimationFrame(animation);
        }
        animation = null;
      }
      return init();
    };
  
    Pace.restart = function() {
      Pace.trigger('restart');
      Pace.stop();
      return Pace.start();
    };
  
    Pace.go = function() {
      var start;
      Pace.running = true;
      bar.render();
      start = now();
      cancelAnimation = false;
      return animation = runAnimation(function(frameTime, enqueueNextFrame) {
        var avg, count, done, element, elements, i, j, remaining, scaler, scalerList, sum, _j, _k, _len1, _len2, _ref2;
        remaining = 100 - bar.progress;
        count = sum = 0;
        done = true;
        for (i = _j = 0, _len1 = sources.length; _j < _len1; i = ++_j) {
          source = sources[i];
          scalerList = scalers[i] != null ? scalers[i] : scalers[i] = [];
          elements = (_ref2 = source.elements) != null ? _ref2 : [source];
          for (j = _k = 0, _len2 = elements.length; _k < _len2; j = ++_k) {
            element = elements[j];
            scaler = scalerList[j] != null ? scalerList[j] : scalerList[j] = new Scaler(element);
            done &= scaler.done;
            if (scaler.done) {
              continue;
            }
            count++;
            sum += scaler.tick(frameTime);
          }
        }
        avg = sum / count;
        bar.update(uniScaler.tick(frameTime, avg));
        if (bar.done() || done || cancelAnimation) {
          bar.update(100);
          Pace.trigger('done');
          return setTimeout(function() {
            bar.finish();
            Pace.running = false;
            return Pace.trigger('hide');
          }, Math.max(options.ghostTime, Math.max(options.minTime - (now() - start), 0)));
        } else {
          return enqueueNextFrame();
        }
      });
    };
  
    Pace.start = function(_options) {
      extend(options, _options);
      Pace.running = true;
      try {
        bar.render();
      } catch (_error) {
        NoTargetError = _error;
      }
      if (!document.querySelector('.pace')) {
        return setTimeout(Pace.start, 50);
      } else {
        Pace.trigger('start');
        return Pace.go();
      }
    };
  
    if (typeof define === 'function' && define.amd) {
      define(['pace'], function() {
        return Pace;
      });
    } else if (typeof exports === 'object') {
      module.exports = Pace;
    } else {
      if (options.startOnPageLoad) {
        Pace.start();
      }
    }
  
  }).call(this);

/*
 * Convert RGB to HEX
 * rgb2hex(hex_value)
 */
  function rgb2hex(rgb) {
    rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
    function hex(x) {
        return ("0" + parseInt(x).toString(16)).slice(-2);
    }
    return "#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3]);
}

/*! Copyright (c) 2011 Piotr Rochala (http://rocha.la)
 * Dual licensed under the MIT (http://www.opensource.org/licenses/mit-license.php)
 * and GPL (http://www.opensource.org/licenses/gpl-license.php) licenses.
 *
 * Slim Scroll Version: 1.3.8
 *
 */
(function($) {

  $.fn.extend({
    slimScroll: function(options) {

      var defaults = {

        // width in pixels of the visible scroll area
        width : 'auto',

        // height in pixels of the visible scroll area
        height : '250px',

        // width in pixels of the scrollbar and rail
        size : '7px',

        // scrollbar color, accepts any hex/color value
        color: '#000',

        // scrollbar position - left/right
        position : 'right',

        // distance in pixels between the side edge and the scrollbar
        distance : '1px',

        // default scroll position on load - top / bottom / $('selector')
        start : 'top',

        // sets scrollbar opacity
        opacity : .4,

        // enables always-on mode for the scrollbar
        alwaysVisible : false,

        // check if we should hide the scrollbar when user is hovering over
        disableFadeOut : false,

        // sets visibility of the rail
        railVisible : false,

        // sets rail color
        railColor : '#333',

        // sets rail opacity
        railOpacity : .2,

        // whether  we should use jQuery UI Draggable to enable bar dragging
        railDraggable : true,

        // defautlt CSS class of the slimscroll rail
        railClass : 'slimScrollRail',

        // defautlt CSS class of the slimscroll bar
        barClass : 'slimScrollBar',

        // defautlt CSS class of the slimscroll wrapper
        wrapperClass : 'slimScrollDiv',

        // check if mousewheel should scroll the window if we reach top/bottom
        allowPageScroll : false,

        // scroll amount applied to each mouse wheel step
        wheelStep : 20,

        // scroll amount applied when user is using gestures
        touchScrollStep : 200,

        // sets border radius
        borderRadius: '7px',

        // sets border radius of the rail
        railBorderRadius : '7px'
      };

      var o = $.extend(defaults, options);

      // do it for every element that matches selector
      this.each(function(){

      var isOverPanel, isOverBar, isDragg, queueHide, touchDif,
        barHeight, percentScroll, lastScroll,
        divS = '<div></div>',
        minBarHeight = 30,
        releaseScroll = false;

        // used in event handlers and for better minification
        var me = $(this);

        // ensure we are not binding it again
        if (me.parent().hasClass(o.wrapperClass))
        {
            // start from last bar position
            var offset = me.scrollTop();

            // find bar and rail
            bar = me.siblings('.' + o.barClass);
            rail = me.siblings('.' + o.railClass);

            getBarHeight();

            // check if we should scroll existing instance
            if ($.isPlainObject(options))
            {
              // Pass height: auto to an existing slimscroll object to force a resize after contents have changed
              if ( 'height' in options && options.height == 'auto' ) {
                me.parent().css('height', 'auto');
                me.css('height', 'auto');
                var height = me.parent().parent().height();
                me.parent().css('height', height);
                me.css('height', height);
              } else if ('height' in options) {
                var h = options.height;
                me.parent().css('height', h);
                me.css('height', h);
              }

              if ('scrollTo' in options)
              {
                // jump to a static point
                offset = parseInt(o.scrollTo);
              }
              else if ('scrollBy' in options)
              {
                // jump by value pixels
                offset += parseInt(o.scrollBy);
              }
              else if ('destroy' in options)
              {
                // remove slimscroll elements
                bar.remove();
                rail.remove();
                me.unwrap();
                return;
              }

              // scroll content by the given offset
              scrollContent(offset, false, true);
            }

            return;
        }
        else if ($.isPlainObject(options))
        {
            if ('destroy' in options)
            {
            	return;
            }
        }

        // optionally set height to the parent's height
        o.height = (o.height == 'auto') ? me.parent().height() : o.height;

        // wrap content
        var wrapper = $(divS)
          .addClass(o.wrapperClass)
          .css({
            position: 'relative',
            overflow: 'hidden',
            width: o.width,
            height: o.height
          });

        // update style for the div
        me.css({
          overflow: 'hidden',
          width: o.width,
          height: o.height
        });

        // create scrollbar rail
        var rail = $(divS)
          .addClass(o.railClass)
          .css({
            width: o.size,
            height: '100%',
            position: 'absolute',
            top: 0,
            display: (o.alwaysVisible && o.railVisible) ? 'block' : 'none',
            'border-radius': o.railBorderRadius,
            background: o.railColor,
            opacity: o.railOpacity,
            zIndex: 90
          });

        // create scrollbar
        var bar = $(divS)
          .addClass(o.barClass)
          .css({
            background: o.color,
            width: o.size,
            position: 'absolute',
            top: 0,
            opacity: o.opacity,
            display: o.alwaysVisible ? 'block' : 'none',
            'border-radius' : o.borderRadius,
            BorderRadius: o.borderRadius,
            MozBorderRadius: o.borderRadius,
            WebkitBorderRadius: o.borderRadius,
            zIndex: 99
          });

        // set position
        var posCss = (o.position == 'right') ? { right: o.distance } : { left: o.distance };
        rail.css(posCss);
        bar.css(posCss);

        // wrap it
        me.wrap(wrapper);

        // append to parent div
        me.parent().append(bar);
        me.parent().append(rail);

        // make it draggable and no longer dependent on the jqueryUI
        if (o.railDraggable){
          bar.bind("mousedown", function(e) {
            var $doc = $(document);
            isDragg = true;
            t = parseFloat(bar.css('top'));
            pageY = e.pageY;

            $doc.bind("mousemove.slimscroll", function(e){
              currTop = t + e.pageY - pageY;
              bar.css('top', currTop);
              scrollContent(0, bar.position().top, false);// scroll content
            });

            $doc.bind("mouseup.slimscroll", function(e) {
              isDragg = false;hideBar();
              $doc.unbind('.slimscroll');
            });
            return false;
          }).bind("selectstart.slimscroll", function(e){
            e.stopPropagation();
            e.preventDefault();
            return false;
          });
        }

        // on rail over
        rail.hover(function(){
          showBar();
        }, function(){
          hideBar();
        });

        // on bar over
        bar.hover(function(){
          isOverBar = true;
        }, function(){
          isOverBar = false;
        });

        // show on parent mouseover
        me.hover(function(){
          isOverPanel = true;
          showBar();
          hideBar();
        }, function(){
          isOverPanel = false;
          hideBar();
        });

        // support for mobile
        me.bind('touchstart', function(e,b){
          if (e.originalEvent.touches.length)
          {
            // record where touch started
            touchDif = e.originalEvent.touches[0].pageY;
          }
        });

        me.bind('touchmove', function(e){
          // prevent scrolling the page if necessary
          if(!releaseScroll)
          {
  		      e.originalEvent.preventDefault();
		      }
          if (e.originalEvent.touches.length)
          {
            // see how far user swiped
            var diff = (touchDif - e.originalEvent.touches[0].pageY) / o.touchScrollStep;
            // scroll content
            scrollContent(diff, true);
            touchDif = e.originalEvent.touches[0].pageY;
          }
        });

        // set up initial height
        getBarHeight();

        // check start position
        if (o.start === 'bottom')
        {
          // scroll content to bottom
          bar.css({ top: me.outerHeight() - bar.outerHeight() });
          scrollContent(0, true);
        }
        else if (o.start !== 'top')
        {
          // assume jQuery selector
          scrollContent($(o.start).position().top, null, true);

          // make sure bar stays hidden
          if (!o.alwaysVisible) { bar.hide(); }
        }

        // attach scroll events
        attachWheel(this);

        function _onWheel(e)
        {
          // use mouse wheel only when mouse is over
          if (!isOverPanel) { return; }

          var e = e || window.event;

          var delta = 0;
          if (e.wheelDelta) { delta = -e.wheelDelta/120; }
          if (e.detail) { delta = e.detail / 3; }

          var target = e.target || e.srcTarget || e.srcElement;
          if ($(target).closest('.' + o.wrapperClass).is(me.parent())) {
            // scroll content
            scrollContent(delta, true);
          }

          // stop window scroll
          if (e.preventDefault && !releaseScroll) { e.preventDefault(); }
          if (!releaseScroll) { e.returnValue = false; }
        }

        function scrollContent(y, isWheel, isJump)
        {
          releaseScroll = false;
          var delta = y;
          var maxTop = me.outerHeight() - bar.outerHeight();

          if (isWheel)
          {
            // move bar with mouse wheel
            delta = parseInt(bar.css('top')) + y * parseInt(o.wheelStep) / 100 * bar.outerHeight();

            // move bar, make sure it doesn't go out
            delta = Math.min(Math.max(delta, 0), maxTop);

            // if scrolling down, make sure a fractional change to the
            // scroll position isn't rounded away when the scrollbar's CSS is set
            // this flooring of delta would happened automatically when
            // bar.css is set below, but we floor here for clarity
            delta = (y > 0) ? Math.ceil(delta) : Math.floor(delta);

            // scroll the scrollbar
            bar.css({ top: delta + 'px' });
          }

          // calculate actual scroll amount
          percentScroll = parseInt(bar.css('top')) / (me.outerHeight() - bar.outerHeight());
          delta = percentScroll * (me[0].scrollHeight - me.outerHeight());

          if (isJump)
          {
            delta = y;
            var offsetTop = delta / me[0].scrollHeight * me.outerHeight();
            offsetTop = Math.min(Math.max(offsetTop, 0), maxTop);
            bar.css({ top: offsetTop + 'px' });
          }

          // scroll content
          me.scrollTop(delta);

          // fire scrolling event
          me.trigger('slimscrolling', ~~delta);

          // ensure bar is visible
          showBar();

          // trigger hide when scroll is stopped
          hideBar();
        }

        function attachWheel(target)
        {
          if (window.addEventListener)
          {
            target.addEventListener('DOMMouseScroll', _onWheel, false );
            target.addEventListener('mousewheel', _onWheel, false );
          }
          else
          {
            document.attachEvent("onmousewheel", _onWheel)
          }
        }

        function getBarHeight()
        {
          // calculate scrollbar height and make sure it is not too small
          barHeight = Math.max((me.outerHeight() / me[0].scrollHeight) * me.outerHeight(), minBarHeight);
          bar.css({ height: barHeight + 'px' });

          // hide scrollbar if content is not long enough
          var display = barHeight == me.outerHeight() ? 'none' : 'block';
          bar.css({ display: display });
        }

        function showBar()
        {
          // recalculate bar height
          getBarHeight();
          clearTimeout(queueHide);

          // when bar reached top or bottom
          if (percentScroll == ~~percentScroll)
          {
            //release wheel
            releaseScroll = o.allowPageScroll;

            // publish approporiate event
            if (lastScroll != percentScroll)
            {
                var msg = (~~percentScroll == 0) ? 'top' : 'bottom';
                me.trigger('slimscroll', msg);
            }
          }
          else
          {
            releaseScroll = false;
          }
          lastScroll = percentScroll;

          // show only when required
          if(barHeight >= me.outerHeight()) {
            //allow window scroll
            releaseScroll = true;
            return;
          }
          bar.stop(true,true).fadeIn('fast');
          if (o.railVisible) { rail.stop(true,true).fadeIn('fast'); }
        }

        function hideBar()
        {
          // only hide when options allow it
          if (!o.alwaysVisible)
          {
            queueHide = setTimeout(function(){
              if (!(o.disableFadeOut && isOverPanel) && !isOverBar && !isDragg)
              {
                bar.fadeOut('slow');
                rail.fadeOut('slow');
              }
            }, 1000);
          }
        }

      });

      // maintain chainability
      return this;
    }
  });

  $.fn.extend({
    slimscroll: $.fn.slimScroll
  });

})(jQuery);

/*!
 * Waves v0.7.6
 * http://fian.my.id/Waves
 *
 * Copyright 2014-2018 Alfiana E. Sibuea and other contributors
 * Released under the MIT license
 * https://github.com/fians/Waves/blob/master/LICENSE
 */

;(function(window, factory) {
  'use strict';

  // AMD. Register as an anonymous module.  Wrap in function so we have access
  // to root via `this`.
  if (typeof define === 'function' && define.amd) {
      define([], function() {
          window.Waves = factory.call(window);
          return window.Waves;
      });
  }

  // Node. Does not work with strict CommonJS, but only CommonJS-like
  // environments that support module.exports, like Node.
  else if (typeof exports === 'object') {
      module.exports = factory.call(window);
  }

  // Browser globals.
  else {
      window.Waves = factory.call(window);
  }
})(typeof global === 'object' ? global : this, function() {
  'use strict';

  var Waves            = Waves || {};
  var $$               = document.querySelectorAll.bind(document);
  var toString         = Object.prototype.toString;
  var isTouchAvailable = 'ontouchstart' in window;


  // Find exact position of element
  function isWindow(obj) {
      return obj !== null && obj === obj.window;
  }

  function getWindow(elem) {
      return isWindow(elem) ? elem : elem.nodeType === 9 && elem.defaultView;
  }

  function isObject(value) {
      var type = typeof value;
      return type === 'function' || type === 'object' && !!value;
  }

  function isDOMNode(obj) {
      return isObject(obj) && obj.nodeType > 0;
  }

  function getWavesElements(nodes) {
      var stringRepr = toString.call(nodes);

      if (stringRepr === '[object String]') {
          return $$(nodes);
      } else if (isObject(nodes) && /^\[object (Array|HTMLCollection|NodeList|Object)\]$/.test(stringRepr) && nodes.hasOwnProperty('length')) {
          return nodes;
      } else if (isDOMNode(nodes)) {
          return [nodes];
      }

      return [];
  }

  function offset(elem) {
      var docElem, win,
          box = { top: 0, left: 0 },
          doc = elem && elem.ownerDocument;

      docElem = doc.documentElement;

      if (typeof elem.getBoundingClientRect !== typeof undefined) {
          box = elem.getBoundingClientRect();
      }
      win = getWindow(doc);
      return {
          top: box.top + win.pageYOffset - docElem.clientTop,
          left: box.left + win.pageXOffset - docElem.clientLeft
      };
  }

  function convertStyle(styleObj) {
      var style = '';

      for (var prop in styleObj) {
          if (styleObj.hasOwnProperty(prop)) {
              style += (prop + ':' + styleObj[prop] + ';');
          }
      }

      return style;
  }

  var Effect = {

      // Effect duration
      duration: 750,

      // Effect delay (check for scroll before showing effect)
      delay: 200,

      show: function(e, element, velocity) {

          // Disable right click
          if (e.button === 2) {
              return false;
          }

          element = element || this;

          // Create ripple
          var ripple = document.createElement('div');
          ripple.className = 'waves-ripple waves-rippling';
          element.appendChild(ripple);

          // Get click coordinate and element width
          var pos       = offset(element);
          var relativeY = 0;
          var relativeX = 0;
          // Support for touch devices
          if('touches' in e && e.touches.length) {
              relativeY   = (e.touches[0].pageY - pos.top);
              relativeX   = (e.touches[0].pageX - pos.left);
          }
          //Normal case
          else {
              relativeY   = (e.pageY - pos.top);
              relativeX   = (e.pageX - pos.left);
          }
          // Support for synthetic events
          relativeX = relativeX >= 0 ? relativeX : 0;
          relativeY = relativeY >= 0 ? relativeY : 0;

          var scale     = 'scale(' + ((element.clientWidth / 100) * 3) + ')';
          var translate = 'translate(0,0)';

          if (velocity) {
              translate = 'translate(' + (velocity.x) + 'px, ' + (velocity.y) + 'px)';
          }

          // Attach data to element
          ripple.setAttribute('data-hold', Date.now());
          ripple.setAttribute('data-x', relativeX);
          ripple.setAttribute('data-y', relativeY);
          ripple.setAttribute('data-scale', scale);
          ripple.setAttribute('data-translate', translate);

          // Set ripple position
          var rippleStyle = {
              top: relativeY + 'px',
              left: relativeX + 'px'
          };

          ripple.classList.add('waves-notransition');
          ripple.setAttribute('style', convertStyle(rippleStyle));
          ripple.classList.remove('waves-notransition');

          // Scale the ripple
          rippleStyle['-webkit-transform'] = scale + ' ' + translate;
          rippleStyle['-moz-transform'] = scale + ' ' + translate;
          rippleStyle['-ms-transform'] = scale + ' ' + translate;
          rippleStyle['-o-transform'] = scale + ' ' + translate;
          rippleStyle.transform = scale + ' ' + translate;
          rippleStyle.opacity = '1';

          var duration = e.type === 'mousemove' ? 2500 : Effect.duration;
          rippleStyle['-webkit-transition-duration'] = duration + 'ms';
          rippleStyle['-moz-transition-duration']    = duration + 'ms';
          rippleStyle['-o-transition-duration']      = duration + 'ms';
          rippleStyle['transition-duration']         = duration + 'ms';

          ripple.setAttribute('style', convertStyle(rippleStyle));
      },

      hide: function(e, element) {
          element = element || this;

          var ripples = element.getElementsByClassName('waves-rippling');

          for (var i = 0, len = ripples.length; i < len; i++) {
              removeRipple(e, element, ripples[i]);
          }

          if (isTouchAvailable) {
              element.removeEventListener('touchend', Effect.hide);
              element.removeEventListener('touchcancel', Effect.hide);
          }

          element.removeEventListener('mouseup', Effect.hide);
          element.removeEventListener('mouseleave', Effect.hide);
      }
  };

  /**
   * Collection of wrapper for HTML element that only have single tag
   * like <input> and <img>
   */
  var TagWrapper = {

      // Wrap <input> tag so it can perform the effect
      input: function(element) {

          var parent = element.parentNode;

          // If input already have parent just pass through
          if (parent.tagName.toLowerCase() === 'i' && parent.classList.contains('waves-effect')) {
              return;
          }

          // Put element class and style to the specified parent
          var wrapper       = document.createElement('i');
          wrapper.className = element.className + ' waves-input-wrapper';
          element.className = 'waves-button-input';

          // Put element as child
          parent.replaceChild(wrapper, element);
          wrapper.appendChild(element);

          // Apply element color and background color to wrapper
          var elementStyle    = window.getComputedStyle(element, null);
          var color           = elementStyle.color;
          var backgroundColor = elementStyle.backgroundColor;

          wrapper.setAttribute('style', 'color:' + color + ';background:' + backgroundColor);
          element.setAttribute('style', 'background-color:rgba(0,0,0,0);');

      },

      // Wrap <img> tag so it can perform the effect
      img: function(element) {

          var parent = element.parentNode;

          // If input already have parent just pass through
          if (parent.tagName.toLowerCase() === 'i' && parent.classList.contains('waves-effect')) {
              return;
          }

          // Put element as child
          var wrapper  = document.createElement('i');
          parent.replaceChild(wrapper, element);
          wrapper.appendChild(element);

      }
  };

  /**
   * Hide the effect and remove the ripple. Must be
   * a separate function to pass the JSLint...
   */
  function removeRipple(e, el, ripple) {

      // Check if the ripple still exist
      if (!ripple) {
          return;
      }

      ripple.classList.remove('waves-rippling');

      var relativeX = ripple.getAttribute('data-x');
      var relativeY = ripple.getAttribute('data-y');
      var scale     = ripple.getAttribute('data-scale');
      var translate = ripple.getAttribute('data-translate');

      // Get delay beetween mousedown and mouse leave
      var diff = Date.now() - Number(ripple.getAttribute('data-hold'));
      var delay = 350 - diff;

      if (delay < 0) {
          delay = 0;
      }

      if (e.type === 'mousemove') {
          delay = 150;
      }

      // Fade out ripple after delay
      var duration = e.type === 'mousemove' ? 2500 : Effect.duration;

      setTimeout(function() {

          var style = {
              top: relativeY + 'px',
              left: relativeX + 'px',
              opacity: '0',

              // Duration
              '-webkit-transition-duration': duration + 'ms',
              '-moz-transition-duration': duration + 'ms',
              '-o-transition-duration': duration + 'ms',
              'transition-duration': duration + 'ms',
              '-webkit-transform': scale + ' ' + translate,
              '-moz-transform': scale + ' ' + translate,
              '-ms-transform': scale + ' ' + translate,
              '-o-transform': scale + ' ' + translate,
              'transform': scale + ' ' + translate
          };

          ripple.setAttribute('style', convertStyle(style));

          setTimeout(function() {
              try {
                  el.removeChild(ripple);
              } catch (e) {
                  return false;
              }
          }, duration);

      }, delay);
  }


  /**
   * Disable mousedown event for 500ms during and after touch
   */
  var TouchHandler = {

      /* uses an integer rather than bool so there's no issues with
       * needing to clear timeouts if another touch event occurred
       * within the 500ms. Cannot mouseup between touchstart and
       * touchend, nor in the 500ms after touchend. */
      touches: 0,

      allowEvent: function(e) {

          var allow = true;

          if (/^(mousedown|mousemove)$/.test(e.type) && TouchHandler.touches) {
              allow = false;
          }

          return allow;
      },
      registerEvent: function(e) {
          var eType = e.type;

          if (eType === 'touchstart') {

              TouchHandler.touches += 1; // push

          } else if (/^(touchend|touchcancel)$/.test(eType)) {

              setTimeout(function() {
                  if (TouchHandler.touches) {
                      TouchHandler.touches -= 1; // pop after 500ms
                  }
              }, 500);

          }
      }
  };


  /**
   * Delegated click handler for .waves-effect element.
   * returns null when .waves-effect element not in "click tree"
   */
  function getWavesEffectElement(e) {

      if (TouchHandler.allowEvent(e) === false) {
          return null;
      }

      var element = null;
      var target = e.target || e.srcElement;

      while (target.parentElement) {
          if ( (!(target instanceof SVGElement)) && target.classList.contains('waves-effect')) {
              element = target;
              break;
          }
          target = target.parentElement;
      }

      return element;
  }

  /**
   * Bubble the click and show effect if .waves-effect elem was found
   */
  function showEffect(e) {

      // Disable effect if element has "disabled" property on it
      // In some cases, the event is not triggered by the current element
      // if (e.target.getAttribute('disabled') !== null) {
      //     return;
      // }

      var element = getWavesEffectElement(e);

      if (element !== null) {

          // Make it sure the element has either disabled property, disabled attribute or 'disabled' class
          if (element.disabled || element.getAttribute('disabled') || element.classList.contains('disabled')) {
              return;
          }

          TouchHandler.registerEvent(e);

          if (e.type === 'touchstart' && Effect.delay) {

              var hidden = false;

              var timer = setTimeout(function () {
                  timer = null;
                  Effect.show(e, element);
              }, Effect.delay);

              var hideEffect = function(hideEvent) {

                  // if touch hasn't moved, and effect not yet started: start effect now
                  if (timer) {
                      clearTimeout(timer);
                      timer = null;
                      Effect.show(e, element);
                  }
                  if (!hidden) {
                      hidden = true;
                      Effect.hide(hideEvent, element);
                  }

                  removeListeners();
              };

              var touchMove = function(moveEvent) {
                  if (timer) {
                      clearTimeout(timer);
                      timer = null;
                  }
                  hideEffect(moveEvent);

                  removeListeners();
              };

              element.addEventListener('touchmove', touchMove, false);
              element.addEventListener('touchend', hideEffect, false);
              element.addEventListener('touchcancel', hideEffect, false);

              var removeListeners = function() {
                  element.removeEventListener('touchmove', touchMove);
                  element.removeEventListener('touchend', hideEffect);
                  element.removeEventListener('touchcancel', hideEffect);
              };
          } else {

              Effect.show(e, element);

              if (isTouchAvailable) {
                  element.addEventListener('touchend', Effect.hide, false);
                  element.addEventListener('touchcancel', Effect.hide, false);
              }

              element.addEventListener('mouseup', Effect.hide, false);
              element.addEventListener('mouseleave', Effect.hide, false);
          }
      }
  }

  Waves.init = function(options) {
      var body = document.body;

      options = options || {};

      if ('duration' in options) {
          Effect.duration = options.duration;
      }

      if ('delay' in options) {
          Effect.delay = options.delay;
      }

      if (isTouchAvailable) {
          body.addEventListener('touchstart', showEffect, false);
          body.addEventListener('touchcancel', TouchHandler.registerEvent, false);
          body.addEventListener('touchend', TouchHandler.registerEvent, false);
      }

      body.addEventListener('mousedown', showEffect, false);
  };


  /**
   * Attach Waves to dynamically loaded inputs, or add .waves-effect and other
   * waves classes to a set of elements. Set drag to true if the ripple mouseover
   * or skimming effect should be applied to the elements.
   */
  Waves.attach = function(elements, classes) {

      elements = getWavesElements(elements);

      if (toString.call(classes) === '[object Array]') {
          classes = classes.join(' ');
      }

      classes = classes ? ' ' + classes : '';

      var element, tagName;

      for (var i = 0, len = elements.length; i < len; i++) {

          element = elements[i];
          tagName = element.tagName.toLowerCase();

          if (['input', 'img'].indexOf(tagName) !== -1) {
              TagWrapper[tagName](element);
              element = element.parentElement;
          }

          if (element.className.indexOf('waves-effect') === -1) {
              element.className += ' waves-effect' + classes;
          }
      }
  };


  /**
   * Cause a ripple to appear in an element via code.
   */
  Waves.ripple = function(elements, options) {
      elements = getWavesElements(elements);
      var elementsLen = elements.length;

      options          = options || {};
      options.wait     = options.wait || 0;
      options.position = options.position || null; // default = centre of element


      if (elementsLen) {
          var element, pos, off, centre = {}, i = 0;
          var mousedown = {
              type: 'mousedown',
              button: 1
          };
          var hideRipple = function(mouseup, element) {
              return function() {
                  Effect.hide(mouseup, element);
              };
          };

          for (; i < elementsLen; i++) {
              element = elements[i];
              pos = options.position || {
                  x: element.clientWidth / 2,
                  y: element.clientHeight / 2
              };

              off      = offset(element);
              centre.x = off.left + pos.x;
              centre.y = off.top + pos.y;

              mousedown.pageX = centre.x;
              mousedown.pageY = centre.y;

              Effect.show(mousedown, element);

              if (options.wait >= 0 && options.wait !== null) {
                  var mouseup = {
                      type: 'mouseup',
                      button: 1
                  };

                  setTimeout(hideRipple(mouseup, element), options.wait);
              }
          }
      }
  };

  /**
   * Remove all ripples from an element.
   */
  Waves.calm = function(elements) {
      elements = getWavesElements(elements);
      var mouseup = {
          type: 'mouseup',
          button: 1
      };

      for (var i = 0, len = elements.length; i < len; i++) {
          Effect.hide(mouseup, elements[i]);
      }
  };

  /**
   * Deprecated API fallback
   */
  Waves.displayEffect = function(options) {
      console.error('Waves.displayEffect() has been deprecated and will be removed in future version. Please use Waves.init() to initialize Waves effect');
      Waves.init(options);
  };

  return Waves;
});

/*!
* jQuery SmartPanels v1.0.0
*
* Copyright 2019, 2020 SmartAdmin WebApp
* Released under Marketplace License (see your license details for usage)
*
* Publish Date: 2018-01-01T17:42Z
*/

(function ($, window, document, undefined) {

//"use strict"; 

var pluginName = 'smartPanel';

/**
 * Check for touch support and set right click events.
 **/
/*var clickEvent = (('ontouchstart' in window) || window.DocumentTouch && document instanceof DocumentTouch ? 
  'clickEvent' : 'click') + '.' + pluginName;*/

var clickEvent;

if (('ontouchstart' in window) || window.DocumentTouch && document instanceof DocumentTouch) {
  clickEvent = 'click tap';
} else {
  clickEvent = 'click';
}

function Plugin(element, options) {
  /**
   * Variables.
   **/
  this.obj = $(element);
  this.o = $.extend({}, $.fn[pluginName].defaults, options);
  this.objId = this.obj.attr('id');
  this.panel = this.obj.find(this.o.panels);
  this.storage = {enabled: this.o.localStorage};
  this.initialized = false;
  this.init();
}

Plugin.prototype = {

  /**
   * Function for the indicator image.
   *
   * @param:
   **/
  _runPanelLoader: function (elm) {
    var self = this;

    if (self.o.localStorage === true) {
      elm.closest(self.o.panels)
      .find('.panel-saving')
      .stop(true, true)
      .fadeIn(100)
      .delay(600)
      .fadeOut(100);
    }
  },

  _loadKeys : function () {
    
    var self = this;
    var panel_url = self.o.pageKey || location.pathname;

    self.storage.keySettings = 'smartPanel_settings_' + panel_url + '_' + self.objId;
    self.storage.keyPosition = 'smartPanel_position_' + panel_url + '_' + self.objId;
  },

  /**
   * Save all settings to the localStorage.
   *
   * @param:
   **/
  _savePanelSettings: function () {

    var self = this;
    var storage = self.storage;

    self._loadKeys();

    var storeSettings = self.obj.find(self.o.panels)
      .map(function () {
        var storeSettingsStr = {};
        storeSettingsStr.id = $(this)
          .attr('id');
        storeSettingsStr.style = $(this)
          .attr('data-panel-attstyle');
        storeSettingsStr.locked = ($(this)
          .hasClass('panel-locked') ? 1 : 0);
        storeSettingsStr.collapsed = ($(this)
          .hasClass('panel-collapsed') ? 1 : 0);
        return storeSettingsStr;
      }).get();

    var storeSettingsObj = JSON.stringify({
      'panel': storeSettings
    });

    /* Place it in the storage(only if needed) */
    if (storage.enabled && storage.getKeySettings != storeSettingsObj) {
      localStorage.setItem(storage.keySettings, storeSettingsObj);
      storage.getKeySettings = storeSettingsObj;

      //if (myapp_config.debugState)
        //console.log("storeSettingsObj:" + storeSettingsObj)
    }

    /**
     * Run the callback function.
     **/
    
    if (typeof self.o.onSave == 'function') {
      self.o.onSave.call(this, null, storeSettingsObj, storage.keySettings);

      if (myapp_config.debugState)
        console.log("keySettings: " + storage.keySettings)
    }
  },

  /**
   * Save positions to the localStorage.
   *
   * @param:
   **/
  _savePanelPosition: function () {

    var self = this;
    var storage = self.storage;

    self._loadKeys();

    var mainArr = self.obj.find(self.o.grid + '.sortable-grid')
      .map(function () {
        var subArr = $(this)
          .children(self.o.panels)
          .map(function () {
            return {
              'id': $(this).attr('id')
            };
          }).get();
        return {
          'section': subArr
        };
      }).get();

    var storePositionObj = JSON.stringify({
      'grid': mainArr
    });

    /* Place it in the storage(only if needed) */
    if (storage.enabled && storage.getKeyPosition != storePositionObj) {
      localStorage.setItem(storage.keyPosition, storePositionObj);
      storage.getKeyPosition = storePositionObj
    }

    /**
     * Run the callback function.
     **/
    if (typeof self.o.onSave == 'function') {
      self.o.onSave.call(this, storePositionObj, storage.keyPosition);
    }
  },

  /**
   * Code that we run at the start.
   *
   * @param:
   **/
  init: function () {

    var self = this;
    
    if (self.initialized) return;

    self._initStorage(self.storage);

    /**
     * Force users to use an id(it's needed for the local storage).
     **/
    if (!$('#' + self.objId)
      .length) {

      //alert('Your panel ID is missing!');
             if (typeof bootbox  != 'undefined') {
                 bootbox.alert("Your panel ID is missing!");
             } else {
                 alert('Your panel ID is missing!');
             }

    }

    /**
     * This will add an extra class that we use to store the
     * panels in the right order.(savety)
     **/

    $(self.o.grid)
      .each(function () {
        if ($(this)
          .find(self.o.panels)
          .length) {
          $(this)
            .addClass('sortable-grid');
        }
      });


    /**
     * SET POSITION PANEL
     **/

    /**
     * Run if data is present.
     **/
    if (self.storage.enabled && self.storage.getKeyPosition) {

      var jsonPosition = JSON.parse(self.storage.getKeyPosition);

      /**
       * Loop the data, and put every panels on the right place.
       **/
      for (var key in jsonPosition.grid) {
        var changeOrder = self.obj.find(self.o.grid + '.sortable-grid')
          .eq(key);
        for (var key2 in jsonPosition.grid[key].section) {
          changeOrder.append($('#' + jsonPosition.grid[key].section[key2].id));
        }
      }

    }

    /**
     * SET SETTINGS PANEL
     **/

    /**
     * Run if data is present.
     **/
    if (self.storage.enabled && self.storage.getKeySettings) {

      var jsonSettings = JSON.parse(self.storage.getKeySettings);

      if (myapp_config.debugState)
        console.log("Panel settings loaded: " + self.storage.getKeySettings)

      /**
       * Loop the data and hide/show the panels and set the inputs in
       * panel to checked(if hidden) and add an indicator class to the div.
       * Loop all labels and update the panel titles.
       **/
      for (var key in jsonSettings.panel) {
        var panelId = $('#' + jsonSettings.panel[key].id);

        /**
         * Set a style(if present).
         **/
        if (jsonSettings.panel[key].style) {
          panelId.attr('data-panel-attstyle', '' + jsonSettings.panel[key].style + '')
            .children('.panel-hdr')
            .removeClassPrefix('bg-')
            .addClass(jsonSettings.panel[key].style);
        }

        /**
         * Toggle content panel.
         **/
        if (jsonSettings.panel[key].collapsed == 1) {
          panelId.addClass('panel-collapsed')
            .children('.panel-container').addClass('collapse').removeClass('show');
        }

        /**
         * Locked panel from sorting.
         **/
        if (jsonSettings.panel[key].locked == 1) {
          panelId.addClass('panel-locked');
        }

      }
    }

    /**
     * Format colors
     **/

    if (self.o.panelColors && self.o.colorButton) {
      var formatedPanelColors = [];
      for (var key in self.o.panelColors) {
        formatedPanelColors.push('<a href="#" class="btn d-inline-block '+ self.o.panelColors[key] +' width-2 height-2 p-0 rounded-0 js-panel-color hover-effect-dot" data-panel-setstyle="'+ self.o.panelColors[key] +'" style="margin:1px;"></a>');
      }
    }


    /**
     * LOOP ALL PANELS
     **/            
    self.panel.each(function () {

      var tPanel = $(this),
        closeButton,
        fullscreenButton,
        collapseButton,
        lockedButton,
        refreshButton,
        colorButton,
        resetButton,
        customButton,
        thisHeader = $(this).children('.panel-hdr'),
        thisContainer = $(this).children('.panel-container');

      /**
       * Dont double wrap(check).
       **/
      if (!thisHeader.parent().attr('role')) {

        /**
         * Adding a helper class to all sortable panels, this will be
         * used to find the panels that are sortable, it will skip the panels
         * that have the dataset 'panels-sortable="false"' set to false.
         **/
        if (self.o.sortable === true && tPanel.data('panel-sortable') === undefined) {
          tPanel.addClass('panel-sortable');
        }

        /**
        * Add a close button to the panel header (if set to true)
        **/
        if (self.o.closeButton === true && tPanel.data('panel-close') === undefined) {
          closeButton = '<a href="#" class="btn btn-panel hover-effect-dot js-panel-close" data-toggle="tooltip" data-offset="0,10" data-original-title="Close"></a>';
        } else {
          closeButton = '';
        }

        /**
        * Add a fullscreen button to the panel header (if set to true).
        **/
        if (self.o.fullscreenButton === true && tPanel.data('panel-fullscreen') === undefined) {
          fullscreenButton = '<a href="#" class="btn btn-panel hover-effect-dot js-panel-fullscreen" data-toggle="tooltip" data-offset="0,10" data-original-title="Fullscreen"></a>';
        } else {
          fullscreenButton = '';
        }

        /**
        * Add a collapse button to the panel header (if set to true).
        **/
        if (self.o.collapseButton === true && tPanel.data('panel-collapsed') === undefined) {
          collapseButton = '<a href="#" class="btn btn-panel hover-effect-dot js-panel-collapse" data-toggle="tooltip" data-offset="0,10" data-original-title="Collapse"></a>'
        } else {
          collapseButton = '';
        }

        /**
        * Add a locked button to the panel header (if set to true).
        **/
        if (self.o.lockedButton === true && tPanel.data('panel-locked') === undefined) {
          lockedButton = '<a href="#" class="dropdown-item js-panel-locked"><span data-i18n="drpdwn.lockpanel">' + self.o.lockedButtonLabel + '</span></a>'
        } else {
          lockedButton = '';
        }

        /**
        * Add a refresh button to the panel header (if set to true).
        **/
        if (self.o.refreshButton === true && tPanel.data('panel-refresh') === undefined) {
          refreshButton = '<a href="#" class="dropdown-item js-panel-refresh"><span data-i18n="drpdwn.refreshpanel">' + self.o.refreshButtonLabel + '</span></a>';
          thisContainer.prepend(
            '<div class="loader"><i class="fal fa-spinner-third fa-spin-4x fs-xxl"></i></div>'
          );
          //append** conflicts with panel > container > content:last child, so changed to prepend
          
        } else {
          refreshButton = '';
        }

        /**
        * Add a color select button to the panel header (if set to true).
        **/
        if (self.o.colorButton === true && tPanel.data('panel-color') === undefined) {
          colorButton = ' <div class="dropdown-multilevel dropdown-multilevel-left">\
                    <div class="dropdown-item">\
                      <span data-i18n="drpdwn.panelcolor">' + self.o.colorButtonLabel + '</span>\
                    </div>\
                    <div class="dropdown-menu d-flex flex-wrap" style="min-width: 9.5rem; width: 9.5rem; padding: 0.5rem">' + formatedPanelColors.join(" ") + '</div>\
                  </div>'
        } else {
          colorButton = '';
        }

        /**
        * Add a reset widget button to the panel header (if set to true).
        **/
        if (self.o.resetButton === true && tPanel.data('panel-reset') === undefined) {
          resetButton = '<div class="dropdown-divider m-0"></div><a href="#" class="dropdown-item js-panel-reset"><span data-i18n="drpdwn.resetpanel">' + self.o.resetButtonLabel + '</span></a>'
        } else {
          resetButton = '';
        }

        /**
        * Add a custom button to the panel header (if set to true).
        **/
        if (self.o.customButton === true && tPanel.data('panel-custombutton') === undefined) {
          customButton = '<a href="#" class="dropdown-item js-panel-custombutton pl-4"><span data-i18n="drpdwn.custombutton">' + self.o.customButtonLabel + '</span></a>'
        } else {
          customButton = '';
        }

        /**
         * Append the image to the panel header.
         **/
        thisHeader.append(
          '<div class="panel-saving mr-2" style="display:none"><i class="fal fa-spinner-third fa-spin-4x fs-xl"></i></div>'
        );

        /**
         * Set the buttons order.
         **/
        var formatButtons = self.o.buttonOrder
          .replace(/%close%/g, closeButton)
          .replace(/%fullscreen%/g, fullscreenButton)
          .replace(/%collapse%/g, collapseButton);

        /**
         * Add a button wrapper to the header.
         **/
        if (closeButton !== '' || fullscreenButton !== '' || collapseButton !== '') {
          thisHeader.append('<div class="panel-toolbar">' + formatButtons + '</div>');
        }

        /**
         * Set the dropdown buttons order.
         **/
        var formatDropdownButtons = self.o.buttonOrderDropdown
          .replace(/%locked%/g, lockedButton)
          .replace(/%color%/g, colorButton)
          .replace(/%refresh%/g, refreshButton)
          .replace(/%reset%/g, resetButton)
          .replace(/%custom%/g, customButton);

        /**
         * Add a button wrapper to the header.
         **/
        if (lockedButton !== '' || colorButton !== '' || refreshButton !== '' || resetButton !== '' || customButton !== '') {
          thisHeader.append('<div class="panel-toolbar"><a href="#" class="btn btn-toolbar-master" data-toggle="dropdown"><i class="fal fa-ellipsis-v"></i></a><div class="dropdown-menu dropdown-menu-animated dropdown-menu-right p-0">' + formatDropdownButtons + '</div></div>');
        }    

        /**
         * Adding roles to some parts.
         **/
        tPanel.attr('role', 'widget')
          .children('div')
          .attr('role', 'content')
          .prev('.panel-hdr')
          .attr('role', 'heading')
          .children('.panel-toolbar')
          .attr('role', 'menu');
      }
    });


    /**
     * SORTABLE
     **/
    /**
     * jQuery UI soratble, this allows users to sort the panels.
     * Notice that this part needs the jquery-ui core to work.
     **/
    if (self.o.sortable === true && jQuery.ui) {
      var sortItem = self.obj.find(self.o.grid + '.sortable-grid')
        .not('[data-panel-excludegrid]');
      sortItem.sortable({
        items: sortItem.find(self.o.panels + '.panel-sortable'),
        connectWith: sortItem,
        placeholder: self.o.placeholderClass,
        cursor: 'move',
        //revert: true,
        opacity: self.o.opacity,
        delay: 0,
        revert: 350,
        cancel: '.btn-panel, .panel-fullscreen .panel-fullscreen, .mod-panel-disable .panel-sortable, .panel-locked.panel-sortable',
        zIndex: 10000,
        handle: self.o.dragHandle,
        forcePlaceholderSize: true,
        forceHelperSize: true,
        update: function (event, ui) {
          /* run pre-loader in the panel */
          self._runPanelLoader(ui.item.children());
          /* store the positions of the plugins */
          self._savePanelPosition();
          /**
           * Run the callback function.
           **/
          if (typeof self.o.onChange == 'function') {
            self.o.onChange.call(this, ui.item);
          }
        }
      }); //you can add  }).disableSelection() if you don't want text to be selected accidently.
    }

    /**
     * CLICKEVENTS
     **/
    self._clickEvents();


    /**
     * DELETE LOCAL STORAGE KEYS
     **/
    if (self.storage.enabled) {
       
      // Delete the settings key.
      $(self.o.deleteSettingsKey)
        .on(clickEvent, this, function (e) {
          var cleared = confirm(self.o.settingsKeyLabel);
          if (cleared) {
            localStorage.removeItem(keySettings);
          }
          e.preventDefault();
        });

      // Delete the position key.
      $(self.o.deletePositionKey)
        .on(clickEvent, this, function (e) {
          var cleared = confirm(self.o.positionKeyLabel);
          if (cleared) {
            localStorage.removeItem(keyPosition);
          }
          e.preventDefault();
        });
    }

    initialized = true;
  },

  /**
   * Initialize storage.
   *
   * @param:
   **/
  _initStorage: function (storage) {

    /**
     * LOCALSTORAGE CHECK
     **/
    storage.enabled = storage.enabled && !! function () {
      var result, uid = +new Date();
      try {
        localStorage.setItem(uid, uid);
        result = localStorage.getItem(uid) == uid;
        localStorage.removeItem(uid);
        return result;
      } catch (e) {}
    }();

    this._loadKeys();

    if (storage.enabled) {

      storage.getKeySettings = localStorage.getItem(storage.keySettings);
      storage.getKeyPosition = localStorage.getItem(storage.keyPosition);
      
    } // end if

  },

  /**
   * Register all click events.
   *
   * @param:
   **/
  _clickEvents: function () {

    var self = this;
    var headers = self.panel.children('.panel-hdr');

    /**
     * Allow users to toggle collapse.
     **/
    headers.on(clickEvent, '.js-panel-collapse', function (e) {

      var tPanel = $(this),
        pPanel = tPanel.closest(self.o.panels);

      /**
       * Close tooltip
       **/
      if( typeof($.fn.tooltip) !== 'undefined' && $('[data-toggle="tooltip"]').length ){
        $(this).tooltip('hide');
      } else {
        console.log("bs.tooltip is not loaded");
      }   

      /**
       * Run function for the indicator image.
       **/
       // pPanel.toggleClass("panel-collapsed");

      pPanel.children('.panel-container').collapse('toggle')
        .on('shown.bs.collapse', function() {
          pPanel.removeClass('panel-collapsed');
          self._savePanelSettings(); 
         }).on('hidden.bs.collapse', function(){
          pPanel.addClass('panel-collapsed');
          self._savePanelSettings(); 
        });

      /*if (pPanel.hasClass('panel-collapsed')) {
        pPanel.removeClass('panel-collapsed')
          .children('.panel-container')
          .slideDown(400, function () {
            self._savePanelSettings(); 
          });
      } else {
        pPanel.addClass('panel-collapsed')
          .children('.panel-container')
          .slideUp(400, function () {
            self._savePanelSettings(); 
          });
      }*/

      /**
       * Run function for the indicator image.
       **/
      self._runPanelLoader(tPanel);


      /**
       * Run the callback function.
       **/
      if (typeof self.o.onCollapse == 'function') {
        self.o.onCollapse.call(this, pPanel);
      }

      /**
       * Lets save the setings.
       **/
       // self._savePanelSettings();             
      
      e.preventDefault();
    });

    /**
     * Allow users to toggle fullscreen.
     **/
    headers.on(clickEvent, '.js-panel-fullscreen', function (e) {

      var tPanel = $(this),
        pPanel = tPanel.closest(self.o.panels);

      /**
       * Close tooltip
       **/
      if( typeof($.fn.tooltip) !== 'undefined' && $('[data-toggle="tooltip"]').length ){
        $(this).tooltip('hide');
      } else {
        console.log("bs.tooltip is not loaded");
      }   

      /**
       * Run function for the indicator image.
       **/
      pPanel.toggleClass("panel-fullscreen");
      myapp_config.root_.toggleClass('panel-fullscreen');

      /**
       * Run function for the indicator image.
       **/
      self._runPanelLoader(tPanel);


      /**
       * Run the callback function.
       **/
      if (typeof self.o.onFullscreen == 'function') {
        self.o.onFullscreen.call(this, pPanel);
      }

      e.preventDefault();
    });

    /**
     * Allow users to close the panel.
     **/
    headers.on(clickEvent, '.js-panel-close', function (e) {

      var tPanel = $(this),
        pPanel = tPanel.closest(self.o.panels),
        pTitle = pPanel.children('.panel-hdr').children('h2').text().trim();

      /**
       * Close tooltip
       **/
      if( typeof($.fn.tooltip) !== 'undefined' && $('[data-toggle="tooltip"]').length ){
        $(this).tooltip('hide');
      } else {
        console.log("bs.tooltip is not loaded");
      }   

      
      var killPanel = function (){

        /**
         * Run function for the indicator image.
         **/
        pPanel.fadeOut(500,function(){
          /* remove panel */
          $(this).remove();
          /**
           * Run the callback function.
           **/
          if (typeof self.o.onClosepanel == 'function') {
            self.o.onClosepanel.call(this, pPanel);
          }
        });  

        /**
         * Run function for the indicator image.
         **/
        self._runPanelLoader(tPanel);

      };


      //backdrop sound
      initApp.playSound('media/sound', 'messagebox')

      if (typeof bootbox  != 'undefined') {

        bootbox.confirm({
          title: "<i class='fal fa-times-circle text-danger mr-2'></i> Do you wish to delete panel <span class='fw-500'>&nbsp;'" +pTitle+"'&nbsp;</span>?",
          message: "<span><strong>Warning:</strong> This action cannot be undone!</span>",
          centerVertical: true,
          swapButtonOrder: true,
          buttons: {
            confirm: {
              label: 'Yes',
              className: 'btn-danger shadow-0'
            },
            cancel: {
              label: 'No',
              className: 'btn-default'
            }
          },
          className: "modal-alert",
          closeButton: false,
          callback: function (result) {
            if (result == true) {
              //close panel 
              killPanel();
            }
          }
        });

      } else {

        if (confirm( 'Do you wish to delete panel ' + pTitle + '?' )) {
          killPanel();
        }

      }				

      e.preventDefault();
    });

    /**
     * Allow users to set widget style (color).
     **/
    headers.on(clickEvent, '.js-panel-color', function (e) {

      var tPanel = $(this),
        pPanel = tPanel.closest(self.o.panels),
        selectedHdr = tPanel.closest('.panel-hdr'),
        val = tPanel.data('panel-setstyle');

      /**
       * Run the callback function.
       **/
      selectedHdr.removeClassPrefix('bg-')
        .addClass(val)
        .closest('.panel')
        .attr('data-panel-attstyle', '' + val + '');              

      /**
       * Run the callback function.
       **/
      if (typeof self.o.onColor == 'function') {
        self.o.onColor.call(this, pPanel);
      }

      /**
       * Run function for the indicator image.
       **/
      self._runPanelLoader(tPanel);

      /**
       * Lets save the setings.
       **/
      self._savePanelSettings();

      e.preventDefault();
    });

    /**
     * Allow users to lock widget to grid - preventing draging.
     **/
    headers.on(clickEvent, '.js-panel-locked', function (e) {

      var tPanel = $(this),
        pPanel = tPanel.closest(self.o.panels);

      /**
       * Run function for the indicator image.
       **/
      pPanel.toggleClass('panel-locked');

      /**
       * Run function for the indicator image.
       **/
      self._runPanelLoader(tPanel);


      /**
       * Run the callback function.
       **/
      if (typeof self.o.onLocked == 'function') {
        self.o.onLocked.call(this, pPanel);
      }

      /**
       * Lets save the setings.
       **/
      self._savePanelSettings();             
      
      e.preventDefault();
    });

    /**
     * Allow users to toggle refresh widget content.
     **/
    headers.on(clickEvent, '.js-panel-refresh', function (e) {

      var tPanel = $(this),
        pPanel = tPanel.closest(self.o.panels),
        //pContainer = pPanel.children('.panel-container'),
        dTimer = pPanel.attr('data-refresh-timer') || 1500;

      /**
       * Run function for the indicator image.
       **/
      pPanel.addClass('panel-refresh').children('.panel-container').addClass('enable-loader')
        .stop(true, true)
        .delay(dTimer).queue(function(){
          //pContainer.removeClass('enable-spinner').dequeue();
          pPanel.removeClass('panel-refresh').children('.panel-container').removeClass('enable-loader').dequeue();
          console.log(pPanel.attr('id') + " refresh complete");
        }); 


      /**
       * Run the callback function.
       **/
      if (typeof self.o.onRefresh == 'function') {
        self.o.onRefresh.call(this, pPanel);
      }       
      
      e.preventDefault();
    });

     /**
     * Allow users to toggle reset widget settings.
     **/
    headers.on(clickEvent, '.js-panel-reset', function (e) {

      var tPanel = $(this),
        pPanel = tPanel.closest(self.o.panels),
        selectedHdr = tPanel.closest('.panel-hdr');

      /**
       * Remove all setting classes.
       **/
      selectedHdr.removeClassPrefix('bg-')
        .closest('.panel')
        .removeClass('panel-collapsed panel-fullscreen panel-locked')
        .attr('data-panel-attstyle', '')
        .children('.panel-container').collapse('show');
          

      /**
       * Run function for the indicator image.
       **/
      self._runPanelLoader(tPanel);    

      /**
       * Lets save the setings.
       **/
      self._savePanelSettings(); 

      /**
       * Run the callback function.
       **/
      if (typeof self.o.onReset == 'function') {
        self.o.onReset.call(this, pPanel);
      }       
      
      e.preventDefault();
    });

    headers = null;

  },

  /**
   * Destroy.
   *
   * @param:
   **/
  destroy: function () {
    var self = this, 
      namespace = '.' + pluginName, 
      sortItem = self.obj.find(self.o.grid + '.sortable-grid').not('[data-panel-excludegrid]');
    self.panel.removeClass('panel-sortable');
    sortItem.sortable('destroy');
    self.panel.children('.panel-hdr').off(namespace);
    $(self.o.deletePositionKey).off(namespace);
    $(window).off(namespace);
    self.obj.removeData(pluginName);
    self.initialized = false;
  }
};

$.fn[pluginName] = function (option) {
  return this.each(function () {

    var $this = $(this),
      data = $this.data(pluginName);

    if (!data) {
      var options = typeof option == 'object' && option;
      $this.data(pluginName, (data = new Plugin(this, options)));
    }
    if (typeof option == 'string') {
      data[option]();
    }
  });
};

/**
 * Default settings(dont change).
 * You can globally override these options
 * by using $.fn.pluginName.key = 'value';
 **/

$.fn[pluginName].defaults = {
  grid: '[class*="col-"]',
  panels: '.panel',
  placeholderClass: 'panel-placeholder',
  dragHandle: '> .panel-hdr > h2',
  localStorage: true,
  onChange: function () {},
  onSave: function () {},
  opacity: 1,
  deleteSettingsKey: '',
  settingsKeyLabel: 'Reset settings?',
  deletePositionKey: '',
  positionKeyLabel: 'Reset position?',
  sortable: true,
  buttonOrder: '%collapse% %fullscreen% %close%',
  buttonOrderDropdown: '%refresh% %locked% %color% %custom% %reset%',
  customButton: false,
  customButtonLabel: "Custom Label",
  onCustom: function () {},
  closeButton: true,
  onClosepanel: function() {
    if (myapp_config.debugState)
      console.log($(this).closest(".panel").attr('id') + " onClosepanel")
  },
  fullscreenButton: true,
  onFullscreen: function() {
    if (myapp_config.debugState)
      console.log($(this).closest(".panel").attr('id') + " onFullscreen")
  },
  collapseButton: true,
  onCollapse: function() {
    if (myapp_config.debugState)
      console.log($(this).closest(".panel").attr('id') + " onCollapse")
  },
  lockedButton: true,
  lockedButtonLabel: "Lock Position",
  onLocked: function() {
    if (myapp_config.debugState)
      console.log($(this).closest(".panel").attr('id') + " onLocked")
  },
  refreshButton: true,
  refreshButtonLabel: "Refresh Content",
  onRefresh: function() {
    if (myapp_config.debugState)
      console.log($(this).closest(".panel").attr('id') + " onRefresh")
  },
  colorButton: true,
  colorButtonLabel: "Panel Style",
  onColor: function() {
    if (myapp_config.debugState)
      console.log($(this).closest(".panel").attr('id') + " onColor")
  },
  panelColors: ['bg-primary-700 bg-success-gradient',
          'bg-primary-500 bg-info-gradient',
          'bg-primary-600 bg-primary-gradient',
          'bg-info-600 bg-primray-gradient',                      
          'bg-info-600 bg-info-gradient',
          'bg-info-700 bg-success-gradient',
          'bg-success-900 bg-info-gradient',
          'bg-success-700 bg-primary-gradient', 
          'bg-success-600 bg-success-gradient',                                 
          'bg-danger-900 bg-info-gradient',
          'bg-fusion-400 bg-fusion-gradient', 
          'bg-faded'],
  resetButton: true,
  resetButtonLabel: "Reset Panel",
  onReset: function() {
    if (myapp_config.debugState)
      console.log( $(this).closest(".panel").attr('id') + " onReset callback" )
  }
};

})(jQuery, window, document);
//--------------------------------------------------------------------------
// HEADSUP!
// Please be sure to re-run gulp again if you do not see the config changes
//--------------------------------------------------------------------------
var myapp_config = {
	/*
	APP VERSION
	*/
	VERSION: '4.5.1',
	/*
	SAVE INSTANCE REFERENCE
	Save a reference to the global object (window in the browser)
	*/
	root_: $('body'), // used for core app reference
	root_logo: $('.page-sidebar > .page-logo'), // used for core app reference
	/*
	DELAY VAR FOR FIRING REPEATED EVENTS (eg., scroll & resize events)
	Lowering the variable makes faster response time but taxing on the CPU
	Reference: http://benalman.com/code/projects/jquery-throttle-debounce/examples/throttle/
	*/
	throttleDelay: 450, // for window.scrolling & window.resizing
	filterDelay: 150,   // for keyup.functions 
	/*
	DETECT MOBILE DEVICES
	Description: Detects mobile device - if any of the listed device is 
	detected a class is inserted to $.root_ and the variable thisDevice 
	is decleard. (so far this is covering most hand held devices)
	*/
	thisDevice: null, // desktop or mobile
	isMobile: (/iphone|ipad|ipod|android|blackberry|mini|windows\sce|palm/i.test(navigator.userAgent.toLowerCase())), //popular device types available on the market
	mobileMenuTrigger: null, // used by pagescrolling and appHeight script, do not change!
	mobileResolutionTrigger: 992, //the resolution when the mobile activation fires
	/*
	DETECT IF WEBKIT
	Description: this variable is used to fire the custom scroll plugin. 
	If it is a non-webkit it will fire the plugin.
	*/
	isWebkit: ((!!window.chrome && !!window.chrome.webstore) === true || Object.prototype.toString.call(window.HTMLElement).indexOf('Constructor') > 0 === true),
	/*
	DETECT CHROME
	Description: this variable is used to fire the custom CSS hacks
	*/
	isChrome: (/chrom(e|ium)/.test(navigator.userAgent.toLowerCase())),
	/*
	DETECT IE (it only detects the newer versions of IE)
	Description: this variable is used to fire the custom CSS hacks
	*/
	isIE: ( (window.navigator.userAgent.indexOf('Trident/') ) > 0 === true ),
	/*
	DEBUGGING MODE
	debugState = true; will spit all debuging message inside browser console.
	*/
	debugState: true, // outputs debug information on browser console
	/*
	Turn on ripple effect for buttons and touch events
	Dependency: 
	*/
	rippleEffect: true, // material design effect that appears on all buttons
	/*
	Primary theme anchor point ID
	This anchor is created dynamically and CSS is loaded as an override theme
	*/
	mythemeAnchor: '#mytheme',
	/*
	Activate last tab
	Stores the last tab in localstorage and activates it
	*/
	activateLastTab: true,	
	/*
	Primary menu anchor point #js-primary-nav
	This is the root anchor point where the menu script will begin its build
	*/
	navAnchor: $('#js-primary-nav'), //changing this may implicate slimscroll plugin target
	navHooks: $('#js-nav-menu'), //changing this may implicate CSS targets
	navAccordion: true, //nav item when one is expanded the other closes
	navInitalized: 'js-nav-built', //nav finished class 
	navFilterInput: $('#nav_filter_input'), //changing this may implicate CSS targets
	navHorizontalWrapperId: 'js-nav-menu-wrapper',
	/*
	The rate at which the menu expands revealing child elements on click
	Lower rate reels faster expansion of nav childs
	*/
	navSpeed: 500, //ms
	/*
	Color profile reference hook (needed for getting CSS value for theme colors in charts and various graphs)
	*/
	mythemeColorProfileID: $('#js-color-profile'),
	/*
	Nav close and open signs
	This uses the fontawesome css class
	*/
	navClosedSign: 'fal fa-angle-down',
	navOpenedSign: 'fal fa-angle-up',
	/*
	Application icon prefix for error messages etc
	other options are fad, fal, fas, far, ni
	*/
	appIconPrefix: 'fal',
	/*
	App date ID
	found inside the breadcrumb unit, displays current date to the app on pageload
	*/
	appDateHook: $('.js-get-date'),
	/*
	* SaveSettings to localStorage
	* DOC: to store settings to a DB instead of LocalStorage see below:
	*    initApp.pushSettings("className1 className2") //sets value
	*    var DB_string = initApp.getSettings(); //returns setting string
	*/
	storeLocally: true,
	/*
	* Used with initApp.loadScripts
	* DOC: Please leave it blank
	*/
	jsArray : []
};

 /*!
 * jQuery app.navigation v1.0.0
 *
 * Copyright 2019, 2020 SmartAdmin WebApp
 * Released under Marketplace License (see your license details for usage)
 *
 * Publish Date: 2018-01-01T17:42Z
 */

(function($) {

	/**
	 * Menu Plugin
	 **/
	$.fn.extend({

		/**
		 * pass the options variable to the function
		 *
		 *   $(id).navigation({ 
		 *       accordion: true,
		 *       animate: 'easeOutExpo',
		 *       speed: 200,
		 *       closedSign: '[+]',
		 *       openedSign: '[-]',
		 *       initClass: 'js-nav-built'
		 *   });
		 *
		 **/
	     
	    navigation: function(options) {

	        var defaults = {
					accordion: true,
					animate: 'easeOutExpo',
					speed: 200,
					closedSign: '[+]',
					openedSign: '[-]',
					initClass: 'js-nav-built'
	            },

	            /**
	             * extend our default options with those provided.
	             **/
	            opts = $.extend(defaults, options),

	            /**
	             * assign current element to variable, in this case is UL element
	             **/
	            self = $(this);

				if (!self.hasClass(opts.initClass)) {

				    /**
				     * confirm build to prevent rebuild error
				     **/
				    self.addClass(opts.initClass);

				    /**
				     * add a mark [+] to a multilevel menu
				     **/
				    self.find("li").each(function() {
				        if ($(this).find("ul").length !== 0) {

				            /**
				             * add the multilevel sign next to the link
				             **/
				            $(this).find("a:first").append("<b class='collapse-sign'>" + opts.closedSign + "</b>");

				            /**
				             * avoid jumping to the top of the page when the href is an #
				             **/
				            if ($(this).find("a:first").attr('href') == "#") {
				                $(this).find("a:first").click(function() {
				                    return false;
				                });
				            }
				        }
				    });

				    /**
				     * add open sign to all active lists
				     **/
				    self.find("li.active").each(function() {
				        $(this).parents("ul")
				        	.parent("li")
				        	.find("a:first")
				        	.attr('aria-expanded', true)
				        	.find("b:first")
				        	.html(opts.openedSign);
				    });

				    /**
				     * click events
				     **/
				    self.find("li a").on('mousedown', function(e) {

				        if ($(this).parent().find("ul").length !== 0) {

				            if (opts.accordion) {

				                /**
				                 * do nothing when the list is open
				                 **/
				                if (!$(this).parent().find("ul").is(':visible')) {

				                    parents = $(this).parent().parents("ul");
				                    visible = self.find("ul:visible");
				                    visible.each(function(visibleIndex) {
				                        var close = true;
				                        parents.each(function(parentIndex) {

				                            if (parents[parentIndex] == visible[visibleIndex]) {

				                                close = false;
				                                return false;
				                            }
				                        });
				                        if (close) {

				                            if ($(this).parent().find("ul") != visible[visibleIndex]) {

				                                $(visible[visibleIndex]).slideUp(opts.speed + 300, opts.animate, function() {
				                                    $(this).parent("li")
				                                    	.removeClass("open")
				                                    	.find("a:first")
				                                    	.attr('aria-expanded', false)
				                                    	.find("b:first")
				                                    	.html(opts.closedSign);

				                                    if (myapp_config.debugState)
				                                        console.log("nav item closed")    
				                                });
				                            }
				                        }
				                    });
				                }
				            }

				            /**
				             * Add active class to open element
				             **/
				            if ($(this).parent().find("ul:first").is(":visible") && !$(this).parent().find("ul:first").hasClass("active")) {

				                $(this).parent().find("ul:first").slideUp(opts.speed + 100, opts.animate, function() {
				                    $(this).parent("li")
				                    	.removeClass("open")
				                    	.find("a:first")
				                    	.attr('aria-expanded', false)
				                    	.find("b:first").delay(opts.speed)
				                    	.html(opts.closedSign);  

				                    if (myapp_config.debugState)
				                        console.log("nav item closed")
				                });
				            } else {
				                $(this).parent().find("ul:first").slideDown(opts.speed, opts.animate, function() {

				                    $(this).parent("li")
				                    	.addClass("open")
				                    	.find("a:first")
				                    	.attr('aria-expanded', true)
				                    	.find("b:first").delay(opts.speed)
				                    	.html(opts.openedSign);

				                    if (myapp_config.debugState)
				                        console.log("nav item opened");

				                });
				            }
				        }
				    });    

				} else {
				    
				    if (myapp_config.debugState)
				        console.log(self.get(0) + " this menu already exists");       
				}

	    },

	    /**
	     * DOC: $(id).destroy();
	     **/
	    navigationDestroy: function() {
	        
			self = $(this);

			if (self.hasClass(myapp_config.navInitalized)) {
			    self.find("li").removeClass("active open");
			    self.find("li a").off('mousedown').removeClass("active").removeAttr("aria-expanded").find(".collapse-sign").remove();
			    self.removeClass(myapp_config.navInitalized).find("ul").removeAttr("style");

			    if (myapp_config.debugState)
			        console.log( self.get(0) + " destroyed");     

			} else {
			    console.log("menu does not exist")
			}

	        
	    }
	}); 

})(jQuery, window, document);
 /*!
 * jQuery menuSlider v1.0.0
 *
 * Copyright 2019, 2020 SmartAdmin WebApp
 * Released under Marketplace License (see your license details for usage)
 *
 * Publish Date: 2019-01-01T17:42Z
 */


;
(function($) {
    var pluginName = 'menuSlider';

    function Plugin(element, options) {

        var $el = $(element),
             el = element;
        options = $.extend({}, $.fn[pluginName].defaults, options);

        function init() {

            /* reset margin */
            $el.css('margin-left', '0px');

            /* add wrapper around navigation */
            $el.wrap( '<div id="'+options.wrapperId+'" class="nav-menu-wrapper d-flex flex-grow-1 width-0 overflow-hidden"></div>' );

            /* add buttons for scroller */
            $('#' + options.wrapperId).before('<a href="#" id="' + options.wrapperId + '-left-btn" class="d-flex align-items-center justify-content-center width-4 btn mt-1 mb-1 mr-2 ml-1 p-0 fs-xxl text-primary"><i class="fal fa-angle-left"></i></a>');
            $('#' + options.wrapperId).after('<a href="#" id="' + options.wrapperId + '-right-btn" class="d-flex align-items-center justify-content-center width-4 btn mt-1 mb-1 mr-1 ml-2 p-0 fs-xxl text-primary"><i class="fal fa-angle-right"></i></a>');

            var getListWidth = $.map($el.children('li:not(.nav-title)'),function(val){ return $(val).outerWidth(true);}),
                /* define variables */
                wrapperWidth,
                currentMarginLeft,
                contentWidth,               
                setMargin,
                maxMargin,


                /* update variables for margin calculations */
                _getValues = function() {
                    wrapperWidth = $('#' + options.wrapperId).outerWidth(); /* incase its changed we get it again */
                    contentWidth = $.map( $el.children('li:not(.nav-title)'), function(val){ return $(val).outerWidth(true); }).reduce(function(a, b) { return a + b; }, 0);
                    currentMarginLeft = parseFloat($el.css('margin-left'));

                    /*console.log("got new values");
                    console.log("wrapperWidth :" + wrapperWidth);
                    console.log("contentWidth :" + contentWidth);
                    console.log("currentMarginLeft :" + currentMarginLeft);*/
                },

                /* scroll right */
                navMenuScrollRight = function() {

                    _getValues();

                    if (-currentMarginLeft + wrapperWidth < contentWidth) {
                        setMargin = Math.max(currentMarginLeft - wrapperWidth, -(contentWidth - wrapperWidth) );
                    } else {
                        setMargin = currentMarginLeft;
                        console.log("right end");
                    }

                    $el.css({
                        marginLeft: setMargin
                    });

                },

                /* scroll left */
                navMenuScrollLeft = function() {

                    _getValues();

                    if (currentMarginLeft < 0) {
                        setMargin = Math.min(currentMarginLeft + wrapperWidth, 0);
                    } else {
                        setMargin = currentMarginLeft;
                        console.log("left end");
                    }

                    $el.css({
                        marginLeft: setMargin
                    });

                };

            /* assign buttons for right*/
            $('#' + options.wrapperId + '-left-btn').click(function(e) {

                navMenuScrollLeft();

                e.preventDefault();
            });

            /* assign buttons for left */
             $('#' + options.wrapperId + '-right-btn').click(function(e) {

                navMenuScrollRight();

                e.preventDefault();
            });

            hook('onInit');
        }

        function option(key, val) {
            if (val) {
                options[key] = val;
            } else {
                return options[key];
            }
        }

        function destroy(options) {
            $el.each(function() {
                var el = this;
                var $el = $(this);

                // Add code to restore the element to its original state...

                $el.css('margin-left', '0px');                           
                $el.unwrap(parent);
                $el.prev().off().remove();
                $el.next().off().remove();

                hook('onDestroy');
                $el.removeData('plugin_' + pluginName);
            });
        }

        function hook(hookName) {
            if (options[hookName] !== undefined) {
                options[hookName].call(el);
            }
        }

        init();

        return {
            option: option,
            destroy: destroy
        };
    }

    $.fn[pluginName] = function(options) {
        if (typeof arguments[0] === 'string') {
            var methodName = arguments[0];
            var args = Array.prototype.slice.call(arguments, 1);
            var returnVal;
            this.each(function() {
                if ($.data(this, 'plugin_' + pluginName) && typeof $.data(this, 'plugin_' + pluginName)[methodName] === 'function') {
                    returnVal = $.data(this, 'plugin_' + pluginName)[methodName].apply(this, args);
                } else {
                    throw new Error('Method ' + methodName + ' does not exist on jQuery.' + pluginName);
                }
            });
            if (returnVal !== undefined) {
                return returnVal;
            } else {
                return this;
            }
        } else if (typeof options === "object" || !options) {
            return this.each(function() {
                if (!$.data(this, 'plugin_' + pluginName)) {
                    $.data(this, 'plugin_' + pluginName, new Plugin(this, options));
                }
            });
        }
    };

    $.fn[pluginName].defaults = {
        onInit: function() {},
        onDestroy: function() {},
        element: myapp_config.navHooks,
        wrapperId: myapp_config.navHorizontalWrapperId
    };


})(jQuery);
 /*!
 * jQuery SmartAdmin v4.0.0
 *
 * Copyright 2019, 2020 SmartAdmin WebApp
 * Released under Marketplace License (see your license details for usage)
 *
 * Publish Date: 2019-01-01T17:42Z
 */
var initApp = (function(app) {

	/**
	 * List filter 
	 * DOC: searches list items, it could be UL or DIV elements
	 * usage: initApp.listFilter($('.list'), $('#intput-id'));
	 *        inside the .list you will need to insert 'data-filter-tags' inside <a>
	 * @param  list
	 * @param  input 
	 * @param  anchor
	 * @return 
	 */
	app.listFilter = function (list, input, anchor) {

		/* add class to filter hide/show */
		if (anchor) {
			$(anchor).addClass('js-list-filter');
		} else {
			$(list).addClass('js-list-filter');
		}

		/* on change keyboard */
		$(input).change( function () {

			var filter = $(this).val().toLowerCase(),
				listPrev = $(list).next().filter('.js-filter-message');
	
			/* when user types more than 1 letter start search filter */
			if(filter.length > 1) {

				/* this finds all data-filter-tags in a list that contain the input val,
				   hiding the ones not containing the input while showing the ones that do */
				
				/* (1) hide all that does not match */   
				$(list).find($("[data-filter-tags]:not([data-filter-tags*='" + filter + "'])"))
					.parentsUntil(list).removeClass('js-filter-show')
					.addClass('js-filter-hide');

				/* (2) hide all that does match */	
				$(list).find($("[data-filter-tags*='" + filter + "']"))
					.parentsUntil(list).removeClass('js-filter-hide')
					.addClass('js-filter-show');

				/* if element exists then print results */	
				if (listPrev){	
					listPrev.text("showing " + $(list).find('li.js-filter-show').length + " from " + $(list).find('[data-filter-tags]').length + " total");
				}

			} else {

				/* when filter length is blank reset the classes */
				$(list).find('[data-filter-tags]').parentsUntil(list).removeClass('js-filter-hide js-filter-show');

				/* if element exists reset print results */
				if (listPrev){
					listPrev.text("");
				}
			} 

			return false;

		}).keyup( $.debounce( myapp_config.filterDelay, function (e) {

			/* fire the above change event after every letter is typed with a delay of 250ms */
			$(this).change();

			/*if(e.keyCode == 13) {
				console.log( $(list).find(".filter-show:not(.filter-hide) > a") );
			}*/

		}));
	};

	/**
	 * Load scripts using lazyload method 
	 * usage: initApp.loadScript("js/my_lovely_script.js", myFunction);
	 * @param  {[type]}   scriptName
	 * @param  {Function} callback  
	 * @return {[type]}             
	 */
	app.loadScript = function (scriptName, callback) {

		if (!myapp_config.jsArray[scriptName]) {	
			var promise = jQuery.Deferred();

			/* adding the script tag to the head as suggested before */
			var body = document.getElementsByTagName('body')[0],
				script = document.createElement('script');
				script.type = 'text/javascript';
				script.src = scriptName;

			/* then bind the event to the callback function
			   there are several events for cross browser compatibility */
			script.onload = function() {
				promise.resolve();
			};

			/* fire the loading */
			body.appendChild(script);
			myapp_config.jsArray[scriptName] = promise.promise();
		}	

		else if (myapp_config.debugState)
			console.log("This script was already loaded: " + scriptName);

		myapp_config.jsArray[scriptName].then(function () {
			if(typeof callback === 'function') {
				callback();
			}
		});
	};

	/**
	 * Javascript Animation for save settings 
	 * @return
	 **/
	app.saveSettings = function () {

		/* if saveSettings function exists */		
		if (typeof saveSettings !== 'undefined' && $.isFunction(saveSettings) && myapp_config.storeLocally) {

			/* call accessIndicator animation */
			initApp.accessIndicator();

			/* call saveSettings function from myapp_config.root_ (HTML) */
			saveSettings();

			if (myapp_config.debugState)
				console.log('Theme settings: ' + '\n' +localStorage.getItem('themeSettings'));

		} else {
			console.log("save function does not exist");
		}
		
	};

	/**
	 * Load external CSS files
	 * @return
	 **/

	app.updateTheme = function (themeName, themeSave) {

		/* if theme anchor exists */
		if ($(myapp_config.mythemeAnchor).length) {
			$(myapp_config.mythemeAnchor).attr('href', themeName);
		} else {
			$('head').append($("<link>", {id: myapp_config.mythemeAnchor.replace('#', ''), "rel": "stylesheet", "href" : themeName }));
		}

		if ( themeSave != undefined ) {
			initApp.saveSettings();
		}
	};

	/**
	 * Reset settings 
	 * DOC: removes all classes from root_ then saves
	 * @return {[type]}
	 **/
	app.resetSettings = function () {

		/* remove all setting classes nav|header|mod|display */
		myapp_config.root_.removeClass (function (index, className) {
			return (className.match (/(^|\s)(nav-|header-|footer-|mod-|display-)\S+/g) || []).join(' ');
		});

		/* detach custom css skin */
		$(myapp_config.mythemeAnchor).attr('href', "");

		/* check non-conflicting plugins */
		initApp.checkNavigationOrientation();

		/* save settings if "storeLocally == true" */
		initApp.saveSettings();

		if (myapp_config.debugState)
			console.log("App reset successful");
	};

	/**
	 * Factory Reset 
	 * DOC: Resets all of localstorage
	 * @return {[type]}
	 **/
	app.factoryReset = function () {

		//backdrop sound
		initApp.playSound('media/sound', 'messagebox');
		//hide settings modal to bootstrap avoid modal bug
		$('.js-modal-settings').modal('hide');

		if (typeof bootbox  != 'undefined') {

			bootbox.confirm({
				title: "<i class='" + myapp_config.appIconPrefix +  " fa-exclamation-triangle text-warning mr-2'></i> You are about to reset all of your localStorage settings",
				message: "<span><strong>Warning:</strong> This action is not reversable. You will lose all your layout settings.</span>",
				centerVertical: true,
				swapButtonOrder: true,
				buttons: {
					confirm: {
						label: 'Factory Reset',
						className: 'btn-warning shadow-0'
					},
					cancel: {
						label: 'Cancel',
						className: 'btn-success'
					}
				},
				className: "modal-alert",
				closeButton: false,
				callback: function (result) {
					if (result == true) {
						//close panel 
						localStorage.clear();
						initApp.resetSettings();
						location.reload();
					}
				}
			});

		} else {

			if (confirm( 'You are about to reset all of your localStorage to null state. Do you wish to continue?' )) {
				localStorage.clear();
				initApp.resetSettings();
				location.reload();
			}

		}				

		//e.preventDefault();

		if (myapp_config.debugState)
			console.log("App reset successful");
	};

	/**
	 * Access Indicator
	 * DOC: spinning icon that appears whenever you
	 * access localstorage or change settings
	 * @return {[type]}
	 **/
	app.accessIndicator = function () {

		myapp_config.root_.addClass('saving').delay(600).queue(function(){
			$(this).removeClass('saving').dequeue();
			return true;
		});

	};

	/*
	 * usage: initApp.pushSettings("className1 className2")
	 * save settings to localstorage: initApp.pushSettings("className1 className2", true)
	 * DOC: pushSettings will also auto save to localStorage if "storeLocally == true" 
	 * we will use this "pushSettings" when loading settings from a database
	 * @param  {[type]} DB_string   
	 * @param  {[type]} saveToLocal
	 * @return {[type]}            
	 */
	app.pushSettings = function (DB_string, saveToLocal) {

		/* clear localstorage variable 'themeSettings' */
		if (saveToLocal != false)
		localStorage.setItem("themeSettings", "");

		/* replace classes from <body> with fetched DB string */
		myapp_config.root_.addClass(DB_string); //ommited .removeClass()

		/* destroy or enable slimscroll */
		initApp.checkNavigationOrientation();

		/* save settings if "storeLocally == true" && "saveToLocal is true" */
		if (saveToLocal != false)
		initApp.saveSettings();

		/* return string */
		return DB_string;
	};

	/*
	 * usage: var DB_string = initApp.removeSettings();
	 * we will use this "removeSettings" when removing certain classes from '_root'
	 * @return {[type]}
	 */
	app.removeSettings = function (classToRemove) {

		if (classToRemove != undefined) {

			// find and remove the specific class name from existing classes
			var settingString =  initApp.getSettings().replace(classToRemove,'');

			/* remove all setting classes nav|header|mod|display */
			myapp_config.root_.removeClass (function (index, className) {
				return (className.match (/(^|\s)(nav-|header-|footer-|mod-|display-)\S+/g) || []).join(' ');
			});

			//push new settings
			initApp.pushSettings( settingString )

		} else {
			console.log("ERROR: You must specify the class you need to remove")
		}
	

		//initApp.pushSettings(layouts);
		
	};

	/*
	 * usage: var DB_string = initApp.getSettings();
	 * we will use this "getSettings" when storing settings to a database
	 * @return {[type]}
	 */
	app.getSettings = function () {

		return myapp_config.root_.attr('class').split(/[^\w-]+/).filter(function(item) {
			return /^(nav|header|footer|mod|display)-/i.test(item);
		}).join(' ');
	};

	/*
	 * Play Sounds
	 * usage: initApp.playSound(path, sound);
	 * @param  {[string]} path 
	 * @param  {[string]} sound 
	 */
	app.playSound = function(path, sound) {
		var audioElement = document.createElement('audio');
		if (navigator.userAgent.match('Firefox/'))
			audioElement.setAttribute('src', path + "/" + sound + '.ogg');
		else
			audioElement.setAttribute('src', path + "/" + sound + '.mp3');

		//$.get();// <-- ??
		audioElement.addEventListener("load", function () {
			audioElement.play();
		}, true);

		audioElement.pause();
		audioElement.play();
	}

	/*
	 * Checks and sets active settings selections
	 * DOC: ?
	 */
	/*app.indicateSelections = function () {

		var classNames = initApp.getSettings()
			.split(' ')
			.map(function(c) {
				return '[data-class="' +  c + '"].js-indicateSelections';
			})
			.join(',');

		$('[data-class].active.js-indicateSelections').removeClass('active');
		$(classNames).addClass('active');

		if (myapp_config.debugState)
			console.log(classNames);
	}*/

	/**
	 * detect browser type
	 * DOC: detect if browser supports webkit CSS
	 * @return {[type]}
	 **/
	app.detectBrowserType = function () {

		/* safari, chrome or IE detect */	
		if(myapp_config.isChrome){

			myapp_config.root_.addClass('chrome webkit');
			return 'chrome webkit';

		} else if (myapp_config.isWebkit) {

			myapp_config.root_.addClass('webkit');
			return 'webkit';

		} else if (myapp_config.isIE) {

			myapp_config.root_.addClass('ie');
			return 'ie';
		}

	};

	/**
	 * Add device type
	 * DOC: Detect if mobile or desktop
	 **/		
	app.addDeviceType = function() {
		
		if (!myapp_config.isMobile) {

			/* desktop */	
			myapp_config.root_.addClass('desktop');
			myapp_config.thisDevice = 'desktop';

		} else {

			/* mobile */
			myapp_config.root_.addClass('mobile');
			myapp_config.thisDevice = 'mobile';
			 
		}

		return myapp_config.thisDevice;
		
	};

	/**
	 * Fix logo position on .header-function-fixed & .nav-function-hidden
	 * DOC: Counters browser bug for fixed position and overflow:hidden for the logo (firefox/IE/Safari)
	 *      Will not fire for webkit devices or Chrome as its not needed
	 * @return {[type]}     
	 **/
	 app.windowScrollEvents = function () {
		if ( myapp_config.root_.is('.nav-function-hidden.header-function-fixed:not(.nav-function-top)') &&  myapp_config.thisDevice === 'desktop') {
			myapp_config.root_logo.css({
				'top': $(window).scrollTop()
			});
		} else if ( myapp_config.root_.is('.header-function-fixed:not(.nav-function-top):not(.nav-function-hidden)') &&  myapp_config.thisDevice === 'desktop') {
			myapp_config.root_logo.attr("style", "");
		}
	 };

	/**
	 * checkNavigationOrientation by checking layout conditions
	 * DOC: sometimes settings can trigger certain plugins; so we check this condition and activate accordingly
	 * E.g: the fixed navigation activates custom scroll plugin for the navigation, but this only happens when
	 *		it detects desktop browser and destroys the plugin when navigation is on top or if its not fixed.
	 * @return {[type]}		
	 **/
	 app.checkNavigationOrientation = function() {

		/**
		 * DOC: add the plugin with the following rules: fixed navigation is selected, top navigation is not active, minify nav is not active, 
		 * and the device is desktop. We do not need to activate the plugin when loading from a mobile phone as it is not needed for touch screens.
		 **/
		switch ( true ) {

			case ( myapp_config.root_.hasClass('nav-function-fixed') && !myapp_config.root_.is('.nav-function-top, .nav-function-minify, .mod-main-boxed') && myapp_config.thisDevice === 'desktop' ):

				/* start slimscroll on nav */
				if ( typeof $.fn.slimScroll !== 'undefined' ) {
					myapp_config.navAnchor.slimScroll({
						height: '100%',
						color: '#fff',
						size: '4px',
						distance: '4px',
						railOpacity: 0.4,
						wheelStep: 10
					});

					if ( document.getElementById(myapp_config.navHorizontalWrapperId) ) {
						myapp_config.navHooks.menuSlider('destroy');
						
						if (myapp_config.debugState)
						console.log("----top controls destroyed");
					}

					if (myapp_config.debugState)
					console.log("slimScroll created");

				} else {
					console.log("$.fn.slimScroll...NOT FOUND");
				}	

				break;			

			case ( myapp_config.navAnchor.parent().hasClass('slimScrollDiv') && myapp_config.thisDevice === 'desktop' && typeof $.fn.slimScroll !== 'undefined' ):

				/* destroy the plugin if it is in violation of rules above */
				myapp_config.navAnchor.slimScroll({ destroy: true });
				myapp_config.navAnchor.attr('style', '');

				/* clear event listners (IE bug) */
				events = jQuery._data( myapp_config.navAnchor[0], "events" );

				if (events) 
					jQuery._removeData( myapp_config.navAnchor[0], "events" );

				if (myapp_config.debugState)
					console.log("slimScroll destroyed");

				break;					

		}

		switch ( true ) {


			/* fires when user switches to nav-function-top on desktop view */
			case ( $.fn.menuSlider && myapp_config.root_.hasClass('nav-function-top') && $("#js-nav-menu-wrapper").length == false && !myapp_config.root_.hasClass('mobile-view-activated') ):

				/* build horizontal navigation */
				myapp_config.navHooks.menuSlider({
					element: myapp_config.navHooks,
					wrapperId: myapp_config.navHorizontalWrapperId
				});

				/* build horizontal nav */
				if (myapp_config.debugState)
				console.log("----top controls created -- case 1");

				break;

			/* fires when user resizes screen to mobile size or app is loaded on mobile resolution */
			case ( myapp_config.root_.hasClass('nav-function-top') && $("#js-nav-menu-wrapper").length == true && myapp_config.root_.hasClass('mobile-view-activated') ):

				/* destroy horizontal nav */
				myapp_config.navHooks.menuSlider('destroy');

				/* build horizontal nav */
				if (myapp_config.debugState)
				console.log("----top controls destroyed -- case 2");

				break;	

			/* fires when users switch off nav-function-top class */
			case ( !myapp_config.root_.hasClass('nav-function-top') && $("#js-nav-menu-wrapper").length == true ):

				/* destroy horizontal nav */
				myapp_config.navHooks.menuSlider('destroy');

				/* build horizontal nav */
				if (myapp_config.debugState)
				console.log("----top controls destroyed -- case 3");				

				break;	

		}

	};
	
	/**
	 * Activate Nav
	 * DOC: activation should not take place if top navigation is on
	 * @param  {[type]} id 
	 * @return {[type]} 
	 **/
	app.buildNavigation = function(id) {
		
		/**
		 * build nav
		 * app.navigation.js
		 **/
		if ($.fn.navigation) {

			$(id).navigation({ 

				accordion : myapp_config.navAccordion,
				speed : myapp_config.navSpeed,
				closedSign : '<em class="' + myapp_config.navClosedSign + '"></em>',
				openedSign : '<em class="' + myapp_config.navOpenedSign + '"></em>',
				initClass: myapp_config.navInitalized

			});

			return (id);
		} else {

			if (myapp_config.debugState)
			console.log( "WARN: navigation plugin missing" );

		}
	};

	/**
	 * Destroy Nav
	 * @param  {[type]} id 
	 * @return {[type]} 
	 **/
	app.destroyNavigation = function(id) {
		
		/**
		 * destroy nav
		 * app.navigation.js
		 **/
		if ($.fn.navigation) {

			$(id).navigationDestroy(); 

			return (id);
		} else {

			if (myapp_config.debugState)
			console.log( "WARN: navigation plugin missing" );

		}
	};

	/**
	 * App Forms
	 * DOC: detects if input is selected or blured
	 * @param  {[type]} parentClass
	 * @param  {[type]} focusClass
	 * @param  {[type]} disabledClass
	 * @return {[type]} 
	 **/
	app.appForms = function(parentClass,focusClass,disabledClass){

		/* go through each .form-control */
		/*$('.form-control').each(function () {
			checkLength(this);
		});*/

		/* if input has 'some value' add class .has-length to .form-group */
		/*function checkLength(e) {
			if (e.value.length > 0 ) {
				$(e).parents(parentClass).addClass(focusClass);
				if($(e).is('[readonly]') || $(e).is('[disabled]')) {
					$(e).parents(parentClass).addClass(disabledClass);
				}
			} else {
				$(e).parents(parentClass).removeClass(focusClass);
				if($(e).is('[readonly]') || $(e).is('[disabled]')) {
					$(e).parents(parentClass).removeClass(disabledClass);
				}
			}
		}*/

		function setClass(e, parentClass, focusClass) {
			$(e).parents(parentClass).addClass(focusClass);
		}

		function deleteClass(e, parentClass, focusClass) {
			/*if(e.value.length) {

			} else {*/
				$(e).parents(parentClass).removeClass(focusClass);
			/*}*/
		}

		$(parentClass).each(function () {
			var input = $(this).find('.form-control');
			input.on('focus', function(){
				setClass(this, parentClass, focusClass);
			});
			input.on('blur', function(){
				deleteClass(this, parentClass, focusClass);
			});
		});
	}; 
	
	/**
	 * Mobile Check Activate
	 * DOC: check on window resize if screen width is less than [value]
	 * @return {int}
	 */
	app.mobileCheckActivation = function(){
		
		if ( window.innerWidth < myapp_config.mobileResolutionTrigger ) {

			myapp_config.root_.addClass('mobile-view-activated');
			myapp_config.mobileMenuTrigger = true;

		} else {

			myapp_config.root_.removeClass('mobile-view-activated');
			myapp_config.mobileMenuTrigger = false;

		}

		if (myapp_config.debugState)
			console.log( "mobileCheckActivation on " + $(window).width() + " | activated: " + myapp_config.mobileMenuTrigger);

		return myapp_config.mobileMenuTrigger;
	}; 

	/**
	 *  Toggle visibility
	 * 	DOC: show and hide content with a button action
	 *  Usage: onclick="initApp.toggleVisibility('foo');"
	 *  @param  {[type]} id 
	 *  @return {[type]}
	 **/
	app.toggleVisibility = function (id) {
		var e = document.getElementById(id);
		if (e.style.display == 'block')
			e.style.display = 'none';
		else
			e.style.display = 'block';
	};

	/**
	 * Miscelaneous DOM ready functions
	 * DOC: start jQuery(document).ready calls
	 * @return {[type]}
	 **/
	app.domReadyMisc = function() {

		/* Add file name path to input files */
		$('.custom-file input').change(function (e) {
			var files = [];
			for (var i = 0; i < $(this)[0].files.length; i++) {
				files.push($(this)[0].files[i].name);
			}
			$(this).next('.custom-file-label').html(files.join(', '));
		});

		/* Give modal backdrop an extra class to make it customizable */
		$('.modal-backdrop-transparent').on('show.bs.modal', function (e) {
			setTimeout(function(){
				$('.modal-backdrop').addClass('modal-backdrop-transparent');
			});
		});
		
		/* Add app date to js-get-date */
		if ( myapp_config.appDateHook.length ) {
			var months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'],
				day = ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'],
				now = new Date(),
				formatted = day[now.getDay()] + ', ' +  
							months[now.getMonth()] + ' ' +  
							now.getDate() + ', ' +
							now.getFullYear();
			myapp_config.appDateHook.text(formatted);				
		}

		/* Check conflicting classes to build/destroy slimscroll */
		initApp.checkNavigationOrientation();

		/* Activate the last tab clicked using localStorage */
		if ( myapp_config.activateLastTab ) {
			
			var lastTab = localStorage.getItem('lastTab');
			 
			$('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
				localStorage.setItem('lastTab', $(this).attr('href'));
			});
			
			if (lastTab) {
				$('[href="' + lastTab + '"]').tab('show');
			} 
		}

		/**
		 * all options:
		 * --------------
			width: '300px',
			height: '500px',
			size: '10px',
			position: 'left',
			color: '#ffcc00',
			alwaysVisible: true,
			distance: '20px',
			start: $('#child_image_element'),
			railVisible: true,
			railColor: '#222',
			railOpacity: 0.3,
			wheelStep: 10,
			allowPageScroll: false,
			disableFadeOut: false
		 **/
		if ( typeof $.fn.slimScroll !== 'undefined' && myapp_config.thisDevice === 'desktop') {

			$('.custom-scroll:not(.disable-slimscroll) >:first-child').slimscroll({
				height: $(this).data('scrollHeight') || '100%',
				size: $(this).data('scrollSize') || '4px',
				position: $(this).data('scrollPosition') || 'right',
				color: $(this).data('scrollColor') || 'rgba(0,0,0,0.6)',
				alwaysVisible: $(this).data('scrollAlwaysVisible') || false,
				distance: $(this).data('scrollDistance') || '4px',
				railVisible: $(this).data('scrollRailVisible') || false,
				railColor: $(this).data('scrollRailColor') || '#fafafa',
				allowPageScroll: false,
				disableFadeOut: false
			});

			if (myapp_config.debugState)
				console.log("%c✔ SlimScroll plugin active", "color: #148f32");	

		} else {
			console.log("WARN! $.fn.slimScroll not loaded or user is on desktop");
			myapp_config.root_.addClass("no-slimscroll");
		}

		/**
		 * Activate listFilters
		 * usage: <input id="inputID" data-listfilter="listFilter" />
		 **/
		if( typeof initApp.listFilter !== 'undefined' && $.isFunction(initApp.listFilter) && $('[data-listfilter]').length ) {


			var inputID = $('[data-listfilter]').attr('id'),
				listFilter = $('[data-listfilter]').attr("data-listfilter");

			/* initApp.listFilter($('.list'), $('#intput-id')); */
			initApp.listFilter(listFilter, '#' + inputID);
		}

		/**
		 * Start bootstrap tooltips
		 **/
		if( typeof($.fn.tooltip) !== 'undefined' && $('[data-toggle="tooltip"]').length ){
			$('[data-toggle="tooltip"]').tooltip(); /*{html: true}*/
		} else {
			console.log("OOPS! bs.tooltip is not loaded");
		}

		/**
		 * Start bootstrap popovers
		 **/
		if( typeof($.fn.popover) !== 'undefined' && $('[data-toggle="popover"]').length ){

			/* BS4 sanatize */
			var myDefaultWhiteList = $.fn.tooltip.Constructor.Default.whiteList

			/* init popover */
			/* data-sanitize="false" was not working so had to add this globally */
			/* DOC: https://getbootstrap.com/docs/4.3/getting-started/javascript/#sanitizer */
			$('[data-toggle="popover"]').popover({sanitize:false}); /*{trigger: "focus"}*/

		} /*else {
			console.log("OOPS! bs.popover is not loaded");
			console.log("this")
		}*/

		/* 
		 * Disable popper.js's forced hardware accelaration styles
		 */
		if( typeof($.fn.dropdown) !== 'undefined'){ 
			Popper.Defaults.modifiers.computeStyle.gpuAcceleration = false;
		} else {
			console.log("OOPS! bs.popover is not loaded");
		} 

		/**
		 * Dropdowns will not close on click
		 * doc: close dropdowns on click outside hit area
		 **/
		$(document).on('click', '.dropdown-menu:not(.js-auto-close):not(.note-dropdown-menu)', function (e) {
			e.stopPropagation();
		});

		/**
		 * Waves effect (plugin has issues with IE9)
		 * DOC: http://fian.my.id/Waves/#start 
		 **/
		if (window.Waves && myapp_config.rippleEffect) {

			Waves.attach('.nav-menu:not(.js-waves-off) a, .btn:not(.js-waves-off):not(.btn-switch), .js-waves-on', ['waves-themed']);
			Waves.init();

			if (myapp_config.debugState)
				console.log("%c✔ Waves plugin active", "color: #148f32");	
			
		} else {
			if (myapp_config.debugState)
				console.log("%c✘ Waves plugin inactive! ", "color: #fd3995");

		}

		/**
		 * Action buttons
		 **/		
		myapp_config.root_
			.on('click touchend', '[data-action]', function(e) {

				var actiontype = $(this).data('action');

				switch ( true ) {

					/**
					 * toggle trigger
					 * Usage 1 (body): <a href="#" data-action="toggle" data-class="add-this-class-to-body">...</a>
					 * Usage 2 (target): <a href="#" data-action="toggle" data-class="add-this-class-to-target" data-target="target">...</a>
					 **/
					case ( actiontype === 'toggle' ):

						var target = $(this).attr('data-target') || myapp_config.root_,
							dataClass = $(this).attr('data-class'),
							inputFocus = $(this).attr('data-focus');

						/* remove previous background image if alternate is selected */
						if ( dataClass.indexOf('mod-bg-') !== -1 ) {
							$(target).removeClass (function (index, css) {
								return (css.match (/(^|\s)mod-bg-\S+/g) || []).join(' ');
							});
						}

						/* trigger class change */
						$(target).toggleClass( dataClass );

						/* this allows us to add active class for dropdown toggle components */
						if ( $(this).hasClass('dropdown-item') ) {
							$(this).toggleClass('active');
						}

						/* focus input if available 
						   FAQ: We had to put a delay timer to slow it down for chrome
						*/
						if(inputFocus != undefined) {
							setTimeout(function(){ $('#' + inputFocus).focus(); }, 200);
						}

						/* save settings */
						if ( typeof classHolder != 'undefined' || classHolder != null ) {

							/* NOTE: saveSettings function is located right after <body> tag */
							initApp.checkNavigationOrientation();
							initApp.saveSettings();
						}

						break;

					/**
					 * toggle swap trigger
					 * Usage (target): <a href="#" data-action="toggle-swap" data-class="root-text" data-target="html">...</a>
					 **/
					case ( actiontype === 'toggle-swap' ):

						var target = $(this).attr('data-target'),
							dataClass = $(this).attr('data-class');

						/* trigger class change */
						$(target).removeClass().addClass( dataClass );

						/* change active for demo */
						if (dataClass.startsWith("root-text")) {
							$('[data-class]').removeClass('active');
							$('[data-class="' + dataClass + '"]').addClass('active');
						}

						break;


					/**
					 * toggle replace trigger
					 * Usage (target): <a href="#" data-action="toggle-swap" data-replaceclass="classesToReplace" data-class="replaceWithClass" data-target="body">...</a>
					 **/
					case ( actiontype === 'toggle-replace' ):

						var target = $(this).attr('data-target') || myapp_config.root_,
							replaceClass = $(this).attr('data-replaceclass')
							dataClass = $(this).attr('data-class') || "";
							savetoLocal = $(this).attr('data-savetolocal') || true;

						/* trigger class change */
						$(target).removeClass( replaceClass ).addClass( dataClass );
						//console.log( replaceClass + " :replace these classes")

						/* save to localStorage */
						if (savetoLocal === true) {
							initApp.saveSettings();
						}

						break;


					/**
					 * panel 'collapse' trigger
					 **/
					case ( actiontype === 'panel-collapse' ):

						var selectedPanel = $(this).closest('.panel');

						selectedPanel.children('.panel-container').collapse('toggle')
						.on('show.bs.collapse', function() {
							selectedPanel.removeClass("panel-collapsed");

							if (myapp_config.debugState)
								console.log( "panel id:" + selectedPanel.attr('id') + " | action: uncollapsed" );

						}).on('hidden.bs.collapse', function(){
							selectedPanel.addClass("panel-collapsed");

							if (myapp_config.debugState)
								console.log( "panel id:" + selectedPanel.attr('id') + " | action: collapsed" );

						});
				
						/* return ID of panel */
						//return selectedPanel.attr('id');

						break;

					/**
					 * panel 'fullscreen' trigger
					 **/
					case ( actiontype === 'panel-fullscreen' ):

						var selectedPanel = $(this).closest('.panel');

						selectedPanel.toggleClass('panel-fullscreen');
						myapp_config.root_.toggleClass('panel-fullscreen');

						if (myapp_config.debugState)
						console.log( "panel id:" + selectedPanel.attr('id') + " | action: fullscreen" );

						/* return ID of panel */
						//return selectedPanel.attr('id');

						break;

					/**
					 * panel 'close' trigger
					 **/
					case ( actiontype === 'panel-close' ):

						var selectedPanel = $(this).closest('.panel');

						var killPanel = function (){

							selectedPanel.fadeOut(500,function(){
								/* remove panel */
								$(this).remove();

								if (myapp_config.debugState)
								console.log( "panel id:" + selectedPanel.attr('id') + " | action: removed" );
							});

						};

						if (typeof bootbox  != 'undefined') {

							initApp.playSound('media/sound', 'messagebox')

							bootbox.confirm({
								title: "<i class='" + myapp_config.appIconPrefix +  " fa-times-circle text-danger mr-2'></i> Do you wish to delete panel <span class='fw-500'>&nbsp;'" +selectedPanel.children('.panel-hdr').children('h2').text().trim()+ "'&nbsp;</span>?",
								message: "<span><strong>Warning:</strong> This action cannot be undone!</span>",
								centerVertical: true,
								swapButtonOrder: true,
								buttons: {
									confirm: {
										label: 'Yes',
										className: 'btn-danger shadow-0'
									},
									cancel: {
										label: 'No',
										className: 'btn-default'
									}
								},
								className: "modal-alert",
								closeButton: false,
								callback: function (result) {

									if (result == true) {
										killPanel();
									}
								}
							});

						} else {
							
							if (confirm( 'Do you wish to delete panel ' + selectedPanel.children('.panel-hdr').children('h2').text().trim() + '?' )) {
								killPanel();
							}

						}

						break;

					/**
					 * update header css, 'theme-update' trigger
					 * eg:  data-action = "theme-update" 
					 *      data-theme = "css/cust-theme-1.css"
					 **/
					case ( actiontype === 'theme-update' ):

						initApp.updateTheme($(this).attr('data-theme'), $(this).attr('data-themesave'));

						break;

					/**
					 * theme 'app-reset' trigger
					 **/
					case ( actiontype === 'app-reset' ):

						initApp.resetSettings();

						break;

					/**
					 * theme 'factory-reset' trigger
					 **/
					case ( actiontype === 'factory-reset' ):

						initApp.factoryReset();

						break;	

					/**
					 * app print
					 * starts print priview for browser
					 **/
					case ( actiontype === 'app-print' ):

						window.print();

						break;

					/**
					 * ondemand
					 * load onDemand scripts
					 **/
					case ( actiontype === 'app-loadscript' ):

						var loadurl = $(this).attr('data-loadurl'),
							loadfunction = $(this).attr('data-loadfunction');

						initApp.loadScript(loadurl,loadfunction);

						break;	

					/**
					 * app language selection
					 * lazyloads i18n plugin and activates selected language
					 **/
					case ( actiontype === 'lang' ):

						var applang = $(this).attr('data-lang').toString();

						if (!$.i18n) {
						//jQuery.getScript('http://url/to/the/script');

							initApp.loadScript("js/i18n/i18n.js", 

								function activateLang () {
									
									$.i18n.init({
										resGetPath: 'media/data/__lng__.json',
										load: 'unspecific',
										fallbackLng: false,
										lng: applang
									}, function (t){
										$('[data-i18n]').i18n();
										$('[data-lang]').removeClass('active');
										$('[data-lang="' + applang + '"]').addClass('active');
									});								
									
								}
							);

						} else {

							i18n.setLng(applang, function(){
								$('[data-i18n]').i18n();
								$('[data-lang]').removeClass('active');
								$(this).addClass('active');
							});

						}

						break;	

					/**
					 * app 'fullscreen' trigger
					 **/
					case ( actiontype === 'app-fullscreen' ):

						/* NOTE: this may not work for all browsers if the browser security does not permit it 
						   IE issues: http://stackoverflow.com/questions/33732805/fullscreen-not-working-in-ie */

						if (!document.fullscreenElement && !document.mozFullScreenElement && !document.webkitFullscreenElement && !document.msFullscreenElement ) {

							if (document.documentElement.requestFullscreen) {
								/* Standard browsers */
								document.documentElement.requestFullscreen();
							} else if (document.documentElement.msRequestFullscreen) {
								/* Internet Explorer */
								document.documentElement.msRequestFullscreen();
							} else if (document.documentElement.mozRequestFullScreen) {
								/* Firefox */
								document.documentElement.mozRequestFullScreen();
							} else if (document.documentElement.webkitRequestFullscreen) {
								/* Chrome */
								document.documentElement.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT);
							}

							if (myapp_config.debugState)
								console.log( "app fullscreen toggle active" );

						} else {

							if (document.exitFullscreen) {
								document.exitFullscreen();
							} else if (document.msExitFullscreen) {
								document.msExitFullscreen();
							} else if (document.mozCancelFullScreen) {
								document.mozCancelFullScreen();
							} else if (document.webkitExitFullscreen) {
								document.webkitExitFullscreen();
							}

							if (myapp_config.debugState)
								console.log("%capp fullscreen toggle inactive! ", "color: #ed1c24");
						}

						break; 
				
					/**
					 * app 'playsound' trigger
					 * usage: data-action="playsound" data-soundpath="media/sound/" data-soundfile="filename" (no file extensions)
					 **/
					case ( actiontype === 'playsound' ):

						var path = $(this).attr('data-soundpath') || "media/sound/",
							sound = $(this).attr('data-soundfile');

						initApp.playSound(path,sound);

						break;

				}

				/* hide tooltip if any present */
				$(this).tooltip('hide');

				if (myapp_config.debugState)
					console.log("data-action clicked: " + actiontype);

				/* stop default link action */				
				e.stopPropagation(); 
				e.preventDefault();		
		}); 

		/**
		 * Windows mobile 8 fix ~
		 * DOC: bootstrap related
		 **/
		if (navigator.userAgent.match(/IEMobile\/10\.0/)) {
			var msViewportStyle = document.createElement('style');
			msViewportStyle.appendChild(
				document.createTextNode(
					'@-ms-viewport{width:auto!important}'
				)
			);
			document.head.appendChild(msViewportStyle)
		};

		/**
		 * Display APP version
		 * DOC: only show this if debug state tree
		 **/
		 if (myapp_config.debugState)
			console.log("%c✔ Finished app.init() v" + myapp_config.VERSION + '\n' + "---------------------------", "color: #148f32");	
	};

	return app;
	
})({});

/*
	"Night is a bag that bursts with the golden dust of dawn..."

	Oh wow, you actually opened this file and read it all the way though! Congrats! 
	Please do drop me a line at @myplaneticket :)

*/
var layouts = (function(setlayout) {

	setlayout.errorMessage = function(layout){
		
		console.log("('" + layout + "')" +" is not a valid entry, enter 'on' or 'off'");
	}

	setlayout.fixedHeader = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('header-function-fixed')
		} else if (layout === 'off') {
			initApp.removeSettings('header-function-fixed')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.fixedNavigation = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('nav-function-fixed')
		} else if (layout === 'off') {
			initApp.removeSettings('nav-function-fixed')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.minifyNavigation = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('nav-function-minify')
		} else if (layout === 'off') {
			initApp.removeSettings('nav-function-minify')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.hideNavigation = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('nav-function-hidden')
		} else if (layout === 'off') {
			initApp.removeSettings('nav-function-hidden')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.horizontalNavigation = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('nav-function-top')
		} else if (layout === 'off') {
			initApp.removeSettings('nav-function-top')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.fixedFooter = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('footer-function-fixed')
		} else if (layout === 'off') {
			initApp.removeSettings('footer-function-fixed')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.boxed = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-main-boxed')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-main-boxed')
		} else {
			layouts.errorMessage(layout);
		}
	};
	//mobile
	setlayout.pushContent = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('nav-mobile-push')
		} else if (layout === 'off') {
			initApp.removeSettings('nav-mobile-push')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.overlay = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('nav-mobile-no-overlay')
		} else if (layout === 'off') {
			initApp.removeSettings('nav-mobile-no-overlay')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.offCanvas = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('nav-mobile-slide-out')
		} else if (layout === 'off') {
			initApp.removeSettings('nav-mobile-slide-out')
		} else {
			layouts.errorMessage(layout);
		}
	};
	//accessibility
	setlayout.bigFonts = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-bigger-font')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-bigger-font')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.highContrast = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-high-contrast')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-high-contrast')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.colorblind = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-color-blind')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-color-blind')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.preloadInside = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-pace-custom')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-pace-custom')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.panelIcons = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-panel-icon')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-panel-icon')
		} else {
			layouts.errorMessage(layout);
		}
	};
	//global
	setlayout.cleanBackground = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-clean-page-bg')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-clean-page-bg')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.hideNavIcons = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-hide-nav-icons')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-hide-nav-icons')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.noAnimation = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-disable-animation')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-disable-animation')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.hideInfoCard = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-hide-info-card')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-hide-info-card')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.leanSubheader = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-lean-subheader')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-lean-subheader')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.hierarchicalNav = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-nav-link')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-nav-link')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.darkNav = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-nav-dark')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-nav-dark')
		} else {
			layouts.errorMessage(layout);
		}
	};
	// ALT Approach
	/*setlayout.modeDark = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-skin-dark')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-skin-dark')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.modeLight = function(layout) {
		if (layout === 'on') {
			initApp.pushSettings('mod-skin-light')
		} else if (layout === 'off') {
			initApp.removeSettings('mod-skin-light')
		} else {
			layouts.errorMessage(layout);
		}
	};
	setlayout.modeDefault = function() {
		layouts.modeDark('off');
		layouts.modeLight('off');
	};*/

	//layouts.fontSize('sm');
	// TODO
	/*setlayout.fontSize = function(layout) {

		switch ( true ) {

			case ( layout === 'sm' ): 
				initApp.pushSettings('mod-skin-light') 
				break;

			case ( layout === 'md' ): 
				initApp.pushSettings('mod-skin-light') 
				break;

			case ( layout === 'lg' ): 
				initApp.pushSettings('mod-skin-light') 
				break;

			case ( layout === 'xl' ): 
				initApp.pushSettings('mod-skin-light') 
				break;

			default: 
				console.log("('" + layout + "')" +" is not a valid entry, enter 'sm', 'md', 'lg', or 'xl'");
				break;
		}	

	};*/

	//layouts.theme(themename.css,true)
	setlayout.theme = function(themename,save) {
		initApp.updateTheme(themename, save);
	};

	//layouts.mode('default');
	setlayout.mode = function(layout) {

		switch ( true ) {

			case ( layout === 'default' ): 
				initApp.removeSettings('mod-skin-light', false);
				initApp.removeSettings('mod-skin-dark', true);
				break;

			case ( layout === 'light' ): 
				initApp.removeSettings('mod-skin-dark', false);
				initApp.pushSettings('mod-skin-light', true);
				break;

			case ( layout === 'dark' ): 
				initApp.removeSettings('mod-skin-light', false);
				initApp.pushSettings('mod-skin-dark', true);
				break;

			default: 
				console.log("('" + layout + "')" +" is not a valid entry, enter 'default', 'light', or 'dark'");
				break;
		}	

	};

	return setlayout;
	
})({});
/**
 * Bind the throttled handler to the resize event.
 * NOTE: Please do not change the order displayed (e.g. 1a, 1b, 2a, 2b...etc)
 **/
$(window).resize(

 	$.throttle( myapp_config.throttleDelay, function (e) {

		 /**
		  * (1a) ADD CLASS WHEN BELOW CERTAIN WIDTH (MOBILE MENU)
		  * Description: tracks the page min-width of #CONTENT and NAV when navigation is resized.
		  * This is to counter bugs for minimum page width on many desktop and mobile devices.
		  **/
		  initApp.mobileCheckActivation();

		 /**
		  * (1b) CHECK NAVIGATION STATUS (IF HORIZONTAL OR VERTICAL)
		  * Description: fires an event to check for navigation orientation.
		  * Based on the condition, it will initliaze or destroy the slimscroll, or horizontal nav plugins
		  **/
		  initApp.checkNavigationOrientation();


		 /** -- insert your resize codes below this line -- **/
	 
	})
); 

/**
 * Bind the throttled handler to the scroll event
 **/
$(window).scroll(

 	$.throttle( myapp_config.throttleDelay, function (e) {

		 /**
		  * FIX APP HEIGHT
		  * Compare the height of nav and content;
		  * If one is longer/shorter than the other, measure them to be equal.
		  * This event is only fired on desktop.
		  **/
		  

		  /** -- insert your other scroll codes below this line -- **/

	})

);

/**
 * Initiate scroll events
 **/
$(window).on('scroll', initApp.windowScrollEvents);

/**
 * DOCUMENT LOADED EVENT
 * DOC: Fire when DOM is ready
 * Do not change order a, b, c, d...
 **/

document.addEventListener('DOMContentLoaded', function() {

	/**
	 * detect desktop or mobile 
	 **/
	initApp.addDeviceType();

	/**
	 * detect Webkit Browser 
	 **/
	initApp.detectBrowserType();

	/**
	 * a. check for mobile view width and add class .mobile-view-activated
	 **/
	initApp.mobileCheckActivation();

 	/**
	 * b. build navigation
	 **/
	initApp.buildNavigation(myapp_config.navHooks);

 	/**
	 * c. initialize nav filter
	 **/
	initApp.listFilter(myapp_config.navHooks, myapp_config.navFilterInput, myapp_config.navAnchor);

 	/**
	 * d. run DOM misc functions
	 **/
	initApp.domReadyMisc();

 	/**
	 * e. run app forms class detectors [parentClass,focusClass,disabledClass]
	 **/
	initApp.appForms('.input-group', 'has-length', 'has-disabled');

}); 

/**
 * Mobile orientation change events
 * DOC: recalculates app height
 **/
$( window ).on( "orientationchange", function( event ) {
	/* reset any .CSS heights and force appHeight function to recalculate */

	if (myapp_config.debugState)
		console.log("orientationchange event");
});

/**
 * Window load function
 * DOC: window focus blur detection
 **/
$(window).on("blur focus", function(e) {
    var prevType = $(this).data("prevType");
    /**
     * reduce double fire issues
     **/
    if (prevType != e.type) {   
        switch (e.type) {
            case "blur":
                myapp_config.root_.toggleClass("blur") 

                if (myapp_config.debugState)
                console.log("blur");
            
                break;
            case "focus":
                myapp_config.root_.toggleClass("blur")
                if (myapp_config.debugState)

                console.log("focused");

                break;
        }
    }

    $(this).data("prevType", e.type);
})

var color = {
	primary: {
		_50:  rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-50').css('color'))  || '#ccbfdf',
		_100: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-100').css('color')) || '#beaed7',
		_200: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-200').css('color')) || '#b19dce',
		_300: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-300').css('color')) || '#a38cc6',
		_400: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-400').css('color')) || '#967bbd',
		_500: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-500').css('color')) || '#886ab5',
		_600: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-600').css('color')) || '#7a59ad',
		_700: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-700').css('color')) || '#6e4e9e',
		_800: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-800').css('color')) || '#62468d',
		_900: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-primary-900').css('color')) || '#563d7c'
	},
	success: {
		_50:  rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-50').css('color'))  || '#7aece0',
		_100: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-100').css('color')) || '#63e9db',
		_200: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-200').css('color')) || '#4de5d5',
		_300: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-300').css('color')) || '#37e2d0',
		_400: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-400').css('color')) || '#21dfcb',
		_500: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-500').css('color')) || '#1dc9b7',
		_600: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-600').css('color')) || '#1ab3a3',
		_700: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-700').css('color')) || '#179c8e',
		_800: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-800').css('color')) || '#13867a',
		_900: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-success-900').css('color')) || '#107066'
	},
	info: {
		_50:  rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-50').css('color'))  || '#9acffa',
		_100: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-100').css('color')) || '#82c4f8',
		_200: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-200').css('color')) || '#6ab8f7',
		_300: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-300').css('color')) || '#51adf6',
		_400: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-400').css('color')) || '#39a1f4',
		_500: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-500').css('color')) || '#2196F3',
		_600: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-600').css('color')) || '#0d8aee',
		_700: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-700').css('color')) || '#0c7cd5',
		_800: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-800').css('color')) || '#0a6ebd',
		_900: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-info-900').css('color')) || '#0960a5'
	},
	warning: {
		_50:  rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-50').css('color'))  || '#ffebc1',
		_100: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-100').css('color')) || '#ffe3a7',
		_200: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-200').css('color')) || '#ffdb8e',
		_300: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-300').css('color')) || '#ffd274',
		_400: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-400').css('color')) || '#ffca5b',
		_500: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-500').css('color')) || '#ffc241',
		_600: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-600').css('color')) || '#ffba28',
		_700: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-700').css('color')) || '#ffb20e',
		_800: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-800').css('color')) || '#f4a500',
		_900: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-warning-900').css('color')) || '#da9400'
	},
	danger: {
		_50:  rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-50').css('color'))  || '#feb7d9',
		_100: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-100').css('color')) || '#fe9ecb',
		_200: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-200').css('color')) || '#fe85be',
		_300: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-300').css('color')) || '#fe6bb0',
		_400: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-400').css('color')) || '#fd52a3',
		_500: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-500').css('color')) || '#fd3995',
		_600: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-600').css('color')) || '#fd2087',
		_700: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-700').css('color')) || '#fc077a',
		_800: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-800').css('color')) || '#e7026e',
		_900: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-danger-900').css('color')) || '#ce0262'
	},
	fusion: {
		_50:  rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-50').css('color'))  || '#909090',
		_100: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-100').css('color')) || '#838383',
		_200: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-200').css('color')) || '#767676',
		_300: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-300').css('color')) || '#696969',
		_400: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-400').css('color')) || '#5d5d5d',
		_500: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-500').css('color')) || '#505050',
		_600: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-600').css('color')) || '#434343',
		_700: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-700').css('color')) || '#363636',
		_800: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-800').css('color')) || '#2a2a2a',
		_900: rgb2hex(myapp_config.mythemeColorProfileID.find('.color-fusion-900').css('color')) || '#1d1d1d'
	}
}

/*
* Global events and methods
*
*/

$(function () {
    $('.modal-body').on('change', 'input[type="file"]', function () {
        var input = $(this);
        var label = input.next('label');
        if (label) {
            label.text(input.val().replace('C:\\fakepath\\', ''));
        }
    });

    $('body').on('focus', '.input-group.bg-white.shadow-inset-2 input[type="text"].form-control', function () {
        $(this).parent('.input-group.bg-white.shadow-inset-2').addClass('has-length');
    });

    $('body').on('blur', '.input-group.bg-white.shadow-inset-2 input[type="text"].form-control', function () {
        $(this).parent('.input-group.bg-white.shadow-inset-2').removeClass('has-length');
    });
});

function mostrarError(jqXHR) {
    //var toast = $('.toast');
    var resultText;
    switch (jqXHR.status) {
        case 401:
            var loginUrl = '/';
            location.href = loginUrl;
            break;
        case 400:
        case 404:
            resultText = jqXHR.responseText;
            //toast.find('.toast-body').html(resultText);
            //toast.toast('show');
            alert(resultText);
            break;
        default:
            resultText = "Se presentó un error inesperado, intente más tarde.";
            //$toast.find('.toast-body').html(resultText);
            //toast.toast('show');
            alert(resultText);
            break;
    }
}